000010 IDENTIFICATION  DIVISION.
000020 CLASS-ID. ADOTest INHERITS Form.
000030 ENVIRONMENT DIVISION.
000040 CONFIGURATION SECTION.
000050 SPECIAL-NAMES.
000060 REPOSITORY.
000070     CLASS Sys-Object AS "System.Object"
000080     CLASS Sys-String AS "System.String"
000090     CLASS Sys-Type AS "System.Type"
000100     CLASS Form AS "System.Windows.Forms.Form"
000110     CLASS Application AS "System.Windows.Forms.Application"
000120     CLASS DataSet AS "System.Data.DataSet"
000130     CLASS DataTable AS "System.Data.DataTable"
000140     CLASS DataColumn AS "System.Data.DataColumn"
000150     CLASS DataColumnArray AS "System.Data.DataColumn[]"
000160     CLASS DataRow AS "System.Data.DataRow"
000170     CLASS DataGrid AS "System.Windows.Forms.DataGrid"
000180     CLASS DataRelation AS "System.Data.DataRelation"
000190     CLASS StringBuilder AS "System.Text.StringBuilder"
000200     PROPERTY P-Controls AS "Controls"
000210     PROPERTY DataType AS "DataType"
000220     PROPERTY ColumnName AS "ColumnName"
000230     PROPERTY ReadOnly AS "ReadOnly"
000240     PROPERTY Unique AS "Unique"
000250     PROPERTY P-Columns AS "Columns"
000260     PROPERTY PrimaryKey AS "PrimaryKey"
000270     PROPERTY Tables AS "Tables"
000280     PROPERTY Rows AS "Rows".
000290 STATIC.
000300 DATA DIVISION.
000310 WORKING-STORAGE SECTION.
000320 PROCEDURE DIVISION.
000330 METHOD-ID. MAIN.
000340 DATA DIVISION.
000350 WORKING-STORAGE SECTION.
000360 77 Obj OBJECT REFERENCE ADOTest.
000370 PROCEDURE DIVISION.
000380          INVOKE ADOTest "New" RETURNING Obj.
000390          INVOKE Application "Run" USING BY VALUE Obj.     
000400 END METHOD MAIN.
000410 END STATIC.
000420 OBJECT.
000430 ENVIRONMENT DIVISION.
000440 DATA DIVISION.
000450 WORKING-STORAGE SECTION.
000460 01 myDataSet OBJECT REFERENCE DataSet.
000470 01 dataGrid1 OBJECT REFERENCE DataGrid.
000480 PROCEDURE DIVISION.
000490 METHOD-ID. NEW.
000500 DATA DIVISION.
000510 WORKING-STORAGE SECTION.
000520 PROCEDURE DIVISION.
000530     INVOKE SELF "InitializeComponent".
000540 END METHOD NEW.
000550
000560 METHOD-ID. INITIALIZECOMPONENT AS "InitializeComponent".
000570 DATA DIVISION.
000580 WORKING-STORAGE SECTION.
000590 PROCEDURE DIVISION.
000600     INVOKE SELF "MakeParentTable".
000610     INVOKE SELF "MakeChildTable".
000620     INVOKE SELF "MakeDataRelation".
000630     INVOKE DataGrid "NEW" RETURNING dataGrid1.
000640*    INVOKE P-Controls OF SELF "Add" USING BY VALUE dataGrid1. 
000650     INVOKE SELF "BindToDataGrid".
000660 END METHOD INITIALIZECOMPONENT.
000670
000680 METHOD-ID. MAKEPARENTTABLE AS "MakeParentTable".
000690 DATA DIVISION.
000700 WORKING-STORAGE SECTION.
000710 01 myDataTable OBJECT REFERENCE DataTable.
000720 01 myDataColumn OBJECT REFERENCE DataColumn.
000730 01 myDataRow OBJECT REFERENCE DataRow.
000740 01 PrimaryKeyColumns OBJECT REFERENCE DataColumnArray.
000750 01 I PIC S9(9) COMP-5.
000760 01 str-builder OBJECT REFERENCE StringBuilder.
000770 01 str OBJECT REFERENCE Sys-String.
000780 01 id-Column OBJECT REFERENCE DataColumn.
000790 PROCEDURE DIVISION.
000800* Create a new DataTable.
000810     INVOKE DataTable "NEW" USING BY VALUE "ParentTable"
000820         RETURNING myDataTable.
000830* Create new DataColumn, set DataType, ColumnName and
000840* add to DataTable.
000850     INVOKE DataColumn "NEW" RETURNING myDataColumn.
000860     SET DataType OF myDataColumn TO
000870         Sys-Type::"GetType"("System.Int32").
000880     SET ColumnName OF myDataColumn TO "id".
000890     SET ReadOnly OF myDataColumn TO B"1".
000900     SET Unique OF myDataColumn TO B"1".
000910* Add the Column to the DataColumnCollection
000920     INVOKE P-Columns OF myDataTable "Add" USING BY VALUE myDataColumn.
000930* Create second column.
000940     INVOKE DataColumn "NEW" RETURNING myDataColumn.
000950     SET DataType OF myDataColumn TO
000960         Sys-Type::"GetType"("System.String").
000970     SET ColumnName OF myDataColumn TO "ParentItem".
000980     SET AutoIncrement OF myDataColumn TO B"0".
000990     SET Caption OF myDataColumn TO "ParentItem".
001000     SET ReadOnly OF myDataColumn TO B"0".
001010     SET Unique OF myDataColumn TO B"0".
001020* Add the column to the table.
001030     INVOKE P-Columns OF myDataTable "Add" USING BY VALUE myDataColumn.
001040* Make the ID column the primary key column.
001050     INVOKE DataColumnArray "NEW" USING BY VALUE 1
001060         RETURNING PrimaryKeyColumns.
001070     INVOKE P-Columns OF myDataTable "get_Item" USING BY VALUE "id"
001080         RETURNING id-Column.
001090     INVOKE PrimaryKeyColumns "Set" USING BY VALUE 0 id-Column.
001100     SET PrimaryKey OF myDataTable TO PrimaryKeyColumns.
001110* Instantiate the DataSet variable.
001120     INVOKE DataSet "NEW" RETURNING myDataSet.
001130* Add the new DataTable to the DataSet.
001140     INVOKE Tables OF myDataSet "Add" USING BY VALUE myDataTable.
001150* Create three new DataRow Objects and add them to the DataTable.
001160     PERFORM VARYING I FROM 0 BY 1 UNTIL I > 2
001170         INVOKE myDataTable "NewRow" RETURNING myDataRow
001180         INVOKE myDataRow "set_Item" USING BY VALUE "id" I
001190         INVOKE StringBuilder "New" USING BY VALUE "ParentItem "
001200             RETURNING str-builder
001210         INVOKE str-builder "Append" USING BY VALUE I
001220             RETURNING str-builder
001230         INVOKE str-builder "ToString" RETURNING str
001240         INVOKE myDataRow "set_Item" USING BY VALUE "ParentItem" str
001250         INVOKE Rows OF myDataTable "Add" USING BY VALUE myDataRow
001260     END-PERFORM.
001270 END METHOD MAKEPARENTTABLE.
001280
001290 METHOD-ID. MAKECHILDTABLE AS "MakeChildTable".
001300 DATA DIVISION.
001310 WORKING-STORAGE SECTION.
001320 01 myDataTable OBJECT REFERENCE DataTable.
001330 01 myDataColumn OBJECT REFERENCE DataColumn.
001340 01 myDataRow OBJECT REFERENCE DataRow.
001350 01 PrimaryKeyColumns OBJECT REFERENCE DataColumnArray.
001360 01 I PIC S9(9) COMP-5.
001370 01 str-builder OBJECT REFERENCE StringBuilder.
001380 01 str OBJECT REFERENCE Sys-String.
001390 01 id-Column OBJECT REFERENCE DataColumn.
001400 PROCEDURE DIVISION.
001410* Create a new DataTable.
001420     INVOKE DataTable "NEW" USING BY VALUE "ChildTable"
001430          RETURNING myDataTable.
001440* Create new DataColumn, set DataType, ColumnName and
001450* add to DataTable.
001460     INVOKE DataColumn "NEW" RETURNING myDataColumn.
001470     SET DataType OF myDataColumn TO
001480          Sys-Type::"GetType"("System.Int32").
001490     SET ColumnName OF myDataColumn TO "childID".
001500     SET ReadOnly OF myDataColumn TO B"1".
001510     SET Unique OF myDataColumn to B"1".
001520     INVOKE P-Columns OF myDataTable "Add" USING BY VALUE myDataColumn.
001530* Create second column.
001540     INVOKE DataColumn "NEW" RETURNING myDataColumn.
001550     SET DataType OF myDataColumn TO
001560          Sys-Type::"GetType"("System.String").
001570     SET ColumnName OF myDataColumn TO "ChildItem".
001580     SET AutoIncrement OF myDataColumn TO B"0".
001590     SET Caption OF myDataColumn TO "ParentItem".
001600     SET ReadOnly OF myDataColumn TO B"0".
001610     SET Unique OF myDataColumn TO B"0".
001620     INVOKE P-Columns OF myDataTable "Add" USING BY VALUE myDataColumn.
001630* Create third column.
001640     INVOKE DataColumn "NEW" RETURNING myDataColumn.
001650     SET DataType OF myDataColumn TO
001660          Sys-Type::"GetType"("System.String").
001670     SET ColumnName OF myDataColumn TO "ParentItem".
001680     SET AutoIncrement OF myDataColumn TO B"0".
001690     SET Caption OF myDataColumn TO "ParentItem".
001700     SET ReadOnly OF myDataColumn TO B"0".
001710     SET Unique OF myDataColumn TO B"0".
001720     INVOKE P-Columns OF myDataTable "Add" USING BY VALUE myDataColumn.
001730* Make the ID column the primary key column.
001740     INVOKE DataColumnArray "NEW" USING BY VALUE 1
001750          RETURNING PrimaryKeyColumns.
001760     INVOKE P-Columns Of myDataTable "get_Item" USING BY VALUE "childID"
001770          RETURNING id-Column.
001780     INVOKE PrimaryKeyColumns "Set" USING BY VALUE 0 id-Column.
001790     SET PrimaryKey OF myDataTable TO PrimaryKeyColumns.
001800*Instantiate the DataSet variable.
001810     INVOKE DataSet "NEW" RETURNING myDataSet.
001820* Add the new DataTable to the DataSet.
001830     INVOKE Tables of myDataSet "Add" USING BY VALUE myDataTable.
001840* Create three sets of DataRow objects, five rows each,
001850* and add to DataTable.
001860     PERFORM VARYING I FROM 0 BY 1 UNTIL I > 4
001870          INVOKE myDataTable "NewRow" RETURNING myDataRow
001880          INVOKE myDataRow "set_Item" USING BY VALUE "childID" I
001890          INVOKE StringBuilder "New" USING BY VALUE "ChildItem "
001900                  RETURNING str-builder
001910          INVOKE str-builder "Append" USING BY VALUE I
001920                  RETURNING str-builder
001930          INVOKE str-builder "ToString" RETURNING str
001940          INVOKE myDataRow "set_Item" USING BY VALUE "ChildItem" str
001950          INVOKE Rows OF myDataTable "Add" USING BY VALUE myDataRow
001960     END-PERFORM.
001970 
001980     PERFORM VARYING I FROM 0 BY 1 UNTIL I > 4
001990          INVOKE myDataTable "NewRow" RETURNING myDataRow
002000          INVOKE myDataRow "set_Item" USING BY VALUE "childID" I
002010          INVOKE StringBuilder "New" USING BY VALUE "ChildItem "
002020                  RETURNING str-builder
002030          INVOKE str-builder "Append" USING BY VALUE I
002040                  RETURNING str-builder
002050          INVOKE str-builder "ToString" RETURNING str
002060          INVOKE myDataRow "set_Item" USING BY VALUE "ChildItem" str
002070          INVOKE Rows OF myDataTable "Add" USING BY VALUE myDataRow
002080     END-PERFORM.
002090 
002100     PERFORM VARYING I FROM 0 BY 1 UNTIL I > 4
002110          INVOKE myDataTable "NewRow" RETURNING myDataRow
002120          INVOKE myDataRow "set_Item" USING BY VALUE "childID" I
002130          INVOKE StringBuilder "NEW" USING BY VALUE "ChildItem "
002140                  RETURNING str-builder
002150          INVOKE str-builder "Append" USING BY VALUE I
002160                  RETURNING str-builder
002170          INVOKE str-builder "ToString" RETURNING str
002180          INVOKE myDataRow "set_Item" USING BY VALUE "ChildItem" str
002190          INVOKE Rows OF myDataTable "Add" USING BY VALUE myDataRow
002200     END-PERFORM.
002210
002220 END METHOD MAKECHILDTABLE.
002230 
002240 METHOD-ID. MAKEDATARELATION AS "MakeDataRelation".
002250 DATA DIVISION.
002260 WORKING-STORAGE SECTION.
002270 01 myDataRelation OBJECT REFERENCE DataRelation.
002280 01 myDataTable OBJECT REFERENCE DataTable.
002290 01 myDataColumn OBJECT REFERENCE DataColumn.
002300 01 id-Column OBJECT REFERENCE DataColumn.
002310 PROCEDURE DIVISION.
002320* Create a new DataTable.
002330     INVOKE DataTable "NEW" USING BY VALUE "RelationTable"
002340          RETURNING myDataTable.
002350* Create new DataColumn, set DataType, ColumnName and
002360* add to DataTable.
002370     INVOKE DataColumn "NEW" RETURNING myDataColumn.
002380     SET DataType OF myDataColumn TO
002390          Sys-Type::"GetType"("System.String").
002400     SET ColumnName OF myDataColumn TO "parentID".
002410     SET ReadOnly OF myDataColumn TO B"1".
002420     SET Unique OF myDataColumn TO B"1".
002430* Add the Column to the DataColumnCollection
002440     INVOKE P-Columns OF myDataTable "Add" USING BY VALUE myDataColumn.
002450*Create second column.
002460     INVOKE DataColumn "NEW" RETURNING myDataColumn.
002470     SET DataType OF myDataColumn TO 
002480          Sys-Type::"GetType"("System.String").
002490     SET ColumnName OF myDataColumn TO "ChildItem".
002500     SET AutoIncrement OF myDataColumn TO B"0".
002510     SET Caption OF myDataColumn TO "ChildItem".
002520     SET ReadOnly OF myDataColumn TO B"1".
002530     SET Unique OF myDataColumn TO B"1".
002540* Add the column to the table.
002550     INVOKE P-Columns OF myDataTable "Add" USING BY VALUE myDataColumn.
002560* Instantiate the DataSet variable.
002570     INVOKE DataSet "NEW" RETURNING myDataSet.
002580* Add the new DataTable to the DataSet.
002590     INVOKE Tables OF myDataSet "Add" USING BY VALUE myDataTable.
002600 END METHOD MAKEDATARELATION.
002610 
002620 METHOD-ID. BINDTODATAGRID AS "BindToDataGrid".
002630 DATA DIVISION.
002640 WORKING-STORAGE SECTION.
002650 PROCEDURE DIVISION.
002660* Instruct the DataGrid to bind to the DataSet, with the
002670* ParentTable as the topmost DataTable.
002680     INVOKE dataGrid1 "SetDataBinding" USING BY VALUE
002690         myDataSet "ParentTable".
002700 END METHOD BINDTODATAGRID.
002710 END OBJECT.
002720 END CLASS ADOTest.
