//
// the recursive quicksort algorithm
// Brad Merrill, May 22, 2001
//
using SortControls;

internal class CombSort : SortPanel
  {
  public override string sortAlg { get { return "Comb"; } }
  public override string sortLang { get { return "C#"; } }

  const float ShrinkFactor = (float)1.3;

  public override void sort(int[] a)
    {
    bool flipped = false;
    int gap, top;

    gap = a.Length;
    do
      {
      gap = (int) ((float) gap / ShrinkFactor);
      switch (gap)
	{
	case 0: /* the smallest gap is 1 - bubble sort */
	  gap = 1;
	  break;
	case 9: /* this is what makes this Combsort11 */
	case 10: 
	  gap = 11;
	  break;
	default: break;
	}
      flipped = false;
      top = a.Length - gap;
      for (int i = 0; i < top; i++)
	{
	if (stopRequested)
	  return;
	int j = i + gap;
	if (a[i] > a[j])
	  {
	  int T = a[i];
	  a[i] = a[j];
	  a[j] = T;
	  flipped = true;
	  }
	pause(i,j);
	}
      }
    while (flipped || (gap > 1));
    /* like the bubble and shell sorts we check for a clean pass */
    }
  }

