000010* MergeSort implemented in COBOL.
000020 CLASS-ID. MERGESORT AS "COBOLMergeSort" INHERITS SORTPANEL.
000030 ENVIRONMENT DIVISION.
000040 CONFIGURATION SECTION.
000050 REPOSITORY.
000060     CLASS SORTPANEL AS "SortControls.SortPanel"
000070     CLASS INT-ARRAY AS "System.Int32[]"
000080     CLASS SYS-STRING AS "System.String"
000090     PROPERTY LEN AS "Length".
000100 OBJECT.
000110 PROCEDURE DIVISION.
000120 METHOD-ID. GET PROPERTY SORTLANG AS "sortLang" OVERRIDE.
000130 DATA DIVISION.
000140 LINKAGE SECTION.
000150 01 LANG USAGE OBJECT REFERENCE SYS-STRING.
000160 PROCEDURE DIVISION RETURNING LANG.
000170     SET LANG TO "COBOL".
000180 END METHOD.
000190 METHOD-ID. GET PROPERTY SORTALG AS "sortAlg" OVERRIDE.
000200 DATA DIVISION.
000210 LINKAGE SECTION.
000220 01 ALG USAGE OBJECT REFERENCE SYS-STRING.
000230 PROCEDURE DIVISION RETURNING ALG.
000240     SET ALG TO "Merge".
000250 END METHOD.
000260 METHOD-ID. COBOL_SORT AS "sort" OVERRIDE.
000270 DATA DIVISION.
000280 WORKING-STORAGE SECTION.
000290 01 M PIC S9(9) COMP-5.
000300 01 WKARRAY OBJECT REFERENCE INT-ARRAY.
000310 LINKAGE SECTION.
000320 01 A OBJECT REFERENCE INT-ARRAY.
000330 PROCEDURE DIVISION USING BY VALUE A.
000340     MOVE LEN OF A TO M
000350     INVOKE INT-ARRAY "NEW" USING BY VALUE M RETURNING WKARRAY
000360     INVOKE A "CopyTo" USING BY VALUE WKARRAY 0
000370     
000380     INVOKE SELF "COBOL_SORT_1" USING BY VALUE WKARRAY A 0
000390 END METHOD COBOL_SORT.
000400 
000410 METHOD-ID. COBOL_SORT_1.
000420 DATA DIVISION.
000430 WORKING-STORAGE SECTION.
000440 01 M PIC S9(9) COMP-5.
000450 01 N PIC S9(9) COMP-5.
000460 01 A1 OBJECT REFERENCE INT-ARRAY.
000470 01 A2 OBJECT REFERENCE INT-ARRAY.
000480 01 I PIC S9(9) COMP-5.
000490 01 WK PIC S9(9) COMP-5.
000500 01 T2 PIC S9(9) COMP-5.
000510 01 VAL PIC S9(9) COMP-5.
000520 01 S PIC 1.
000530 LINKAGE SECTION.
000540 01 WKARRAY OBJECT REFERENCE INT-ARRAY.
000550 01 A OBJECT REFERENCE INT-ARRAY.
000560 01 T PIC S9(9) COMP-5.
000570 PROCEDURE DIVISION USING BY VALUE WKARRAY A T.
000580     SET S TO stopRequested OF SELF
000590     IF S = B"1" THEN
000600         EXIT METHOD
000610     END-IF
000620     IF LEN OF WKARRAY > 1 THEN
000630         COMPUTE M = LEN OF WKARRAY / 2
000640         COMPUTE N = LEN OF WKARRAY - M
000650         
000660         INVOKE INT-ARRAY "NEW" USING BY VALUE M RETURNING A1
000670         INVOKE INT-ARRAY "NEW" USING BY VALUE N RETURNING A2
000680         PERFORM VARYING I FROM 0 BY 1 UNTIL I >= M
000690             INVOKE WKARRAY "Get" USING BY VALUE I RETURNING VAL
000700             INVOKE A1 "Set" USING BY VALUE I VAL
000710         END-PERFORM
000720         PERFORM VARYING I FROM 0 BY 1 UNTIL I >= N
000730             COMPUTE WK = M + I
000740             INVOKE WKARRAY "Get" USING BY VALUE WK RETURNING VAL
000750             INVOKE A2 "Set" USING BY VALUE I VAL
000760         END-PERFORM
000770         
000780         INVOKE SELF "COBOL_SORT_1" USING BY VALUE A1 A T
000790         COMPUTE T2 = T + M
000800         INVOKE SELF "COBOL_SORT_1" USING BY VALUE A2 A T2
000810         
000820         INVOKE SELF "COBOL_MERGE" USING BY VALUE A1 A2 WKARRAY A T
000830     END-IF
000840 END METHOD COBOL_SORT_1.
000850 
000860 METHOD-ID. COBOL_MERGE.
000870 DATA DIVISION.
000880 WORKING-STORAGE SECTION.
000890 01 I PIC S9(9) COMP-5.
000900 01 J PIC S9(9) COMP-5.
000910 01 WK PIC S9(9) COMP-5.
000920 01 W2 PIC S9(9) COMP-5.
000930 01 W3 PIC S9(9) COMP-5.
000940 01 VAL PIC S9(9) COMP-5.
000950 01 S PIC 1.
000960 LINKAGE SECTION.
000970 01 A1 OBJECT REFERENCE INT-ARRAY.
000980 01 A2 OBJECT REFERENCE INT-ARRAY.
000990 01 WKARRAY OBJECT REFERENCE INT-ARRAY.
001000 01 A OBJECT REFERENCE INT-ARRAY.
001010 01 T PIC S9(9) COMP-5.
001020 PROCEDURE DIVISION USING BY VALUE A1 A2 WKARRAY A T.
001030     MOVE 0 TO I
001040     MOVE 0 TO J
001050     PERFORM WITH NO LIMIT
001060         SET S TO stopRequested OF SELF
001070         IF S = B"1" THEN
001080             EXIT METHOD
001090         END-IF
001100         IF I >= LEN OF A1 AND J >= LEN OF A2 THEN
001110             EXIT PERFORM
001120         END-IF
001130         
001140         COMPUTE WK = I + J
001150         
001160         IF I < LEN OF A1 AND J < LEN OF A2 THEN
001170             IF A1::"Get"(I) < A2::"Get"(J) THEN
001180                 COMPUTE W2 = T + WK
001190                 COMPUTE W3 = T + I
001200                 INVOKE A1 "Get" USING BY VALUE I RETURNING VAL
001210                 INVOKE WKARRAY "Set" USING BY VALUE WK VAL
001220                 INVOKE A "Set" USING BY VALUE W2 VAL
001230                 ADD 1 TO I
001240                 INVOKE SELF "pause" USING BY VALUE W2 W3
001250             ELSE
001260                 COMPUTE W2 = T + WK
001270                 COMPUTE W3 = T + J + LEN OF A1
001280                 INVOKE A2 "Get" USING BY VALUE J RETURNING VAL
001290                 INVOKE WKARRAY "Set" USING BY VALUE WK VAL
001300                 INVOKE A "Set" USING BY VALUE W2 VAL
001310                 ADD 1 TO J
001320                 INVOKE SELF "pause" USING BY VALUE W2 W3
001330             END-IF
001340         ELSE
001350             IF J >= LEN OF A2 THEN
001360                 COMPUTE W2 = T + WK
001370                 COMPUTE W3 = T + I
001380                 INVOKE A1 "Get" USING BY VALUE I RETURNING VAL
001390                 INVOKE WKARRAY "Set" USING BY VALUE WK VAL
001400                 INVOKE A "Set" USING BY VALUE W2 VAL
001410                 ADD 1 TO I
001420                 INVOKE SELF "pause" USING BY VALUE W2 W3
001430             ELSE
001440                 COMPUTE W2 = T + WK
001450                 COMPUTE W3 = T + J + LEN OF A1
001460                 INVOKE A2 "Get" USING BY VALUE J RETURNING VAL
001470                 INVOKE WKARRAY "Set" USING BY VALUE WK VAL
001480                 INVOKE A "Set" USING BY VALUE W2 VAL
001490                 ADD 1 TO J
001500                 INVOKE SELF "pause" USING BY VALUE W2 W3
001510             END-IF
001520         END-IF
001530     END-PERFORM
001540     INVOKE SELF "pause"
001550 END METHOD COBOL_MERGE.
001560 END OBJECT.
001570 END CLASS MERGESORT.
