//
// the merge sort algorithm
// Brad Merrill, May 22, 2001
//
using SortControls;

internal class MergeSort : SortPanel
  {
  public override string sortAlg { get { return "Merge"; } }
  public override string sortLang { get { return "C#"; } }

  void merge(int[] a, int beg, int end)
    {
    int lo = beg;
    int hi = end;
    pause(lo, hi);
    if (lo >= hi)
      return;
    int mid = (lo + hi) / 2;
    merge(a, lo, mid);
    if (stopRequested)
      return;
    merge(a, mid + 1, hi);
    if (stopRequested)
      return;
    int end_lo = mid;
    int beg_hi = mid + 1;
    while ((lo <= end_lo) && (beg_hi <= hi))
      {
      pause(lo);
      if (stopRequested)
	return;
      if (a[lo] < a[beg_hi])
	{
	lo++;
	}
      else
	{
	int t = a[beg_hi];
	for (int i = beg_hi - 1; i >= lo; i--)
	  {
	  a[i+1] = a[i];
	  pause(lo, i);
	  if (stopRequested)
	    return;
	  }
	a[lo] = t;
	lo++;
	end_lo++;
	beg_hi++;
	}
      }
    }

  public override void sort(int[] a)
    {
    merge(a, 0, a.Length-1);
    }
  }
