//
// the merge sort algorithm, removing recursion
// Brad Merrill, May 22, 2001
//
using SortControls;

internal class Stack
  {
  private int[] stack;
  private int p;

  public Stack(int max)
    {
    stack = new int[max];
    p = 0;
    }

  public Stack() : this(100) { }
  public void Push(int v) { stack[p++] = v; }
  public int Pop() { return stack[--p]; }
  public bool IsEmpty { get { return (p == 0); } }
  }

internal class MergeStackSort : SortPanel
  {
  public override string sortAlg { get { return "MergeStack"; } }
  public override string sortLang { get { return "C#"; } }

  void merge(int[] a, int lo, int hi)
    {
    int mid = (lo + hi) / 2;
    int end_lo = mid;
    int beg_hi = mid + 1;
    while ((lo <= end_lo) && (beg_hi <= hi))
      {
      pause(lo);
      if (stopRequested)
	return;
      if (a[lo] < a[beg_hi])
	{
	lo++;
	}
      else
	{
	int t = a[beg_hi];
	for (int i = beg_hi - 1; i >= lo; i--)
	  {
	  a[i+1] = a[i];
	  pause(lo, i);
	  if (stopRequested)
	    return;
	  }
	a[lo] = t;
	lo++;
	end_lo++;
	beg_hi++;
	}
      }
    }

  void mergeStack(int[] a, int lo, int hi)
    {
    Stack sf = new Stack(a.Length);
    pause(lo, hi);

    for (;;)
      {
      while (hi > lo)
	{
	if (stopRequested)
	  return;
	int mid = (lo + hi) / 2;
	if (mid > hi-mid)
	  {
	  sf.Push(lo);
	  sf.Push(mid);
	  pause(lo, mid);
	  lo = mid+1;
	  }
	else
	  {
	  sf.Push(mid+1);
	  sf.Push(hi);
	  pause(mid, hi);
	  hi = mid-1;
	  }
	}
      if (sf.IsEmpty)
	break;
      hi = sf.Pop();
      lo = sf.Pop();
      merge(a, lo, hi);
      }
    }

  public override void sort(int[] a)
    {
    mergeStack(a, 0, a.Length-1);
    }
  }
