//
// the recursive quicksort algorithm
// Brad Merrill, May 22, 2001
//
using SortControls;

internal class QSort : SortPanel
  {
  public override string sortAlg { get { return "Quick"; } }
  public override string sortLang { get { return "C#"; } }

  bool pauseTrue(int i, int j)
    {
    pause(i,j);
    return (true);
    }

  int partition(int[] a, int l, int r)
    {
    int i;
    int j;
    int v;
    int t;

    v = a[r];
    i = l-1;
    j = r;
    for (;;)
      {
      while (i < r && a[++i] <= v && pauseTrue(l,i) && !stopRequested)
	;
      while (j > l && a[--j] >= v && pauseTrue(r,j) && !stopRequested)
	;
      if (stopRequested)
	return (-1);
      if (i >= j)
	break;
      t = a[i];
      a[i] = a[j];
      a[j] = t;
      pause(i, j);
      }
    t = a[i];
    a[i] = a[r];
    a[r] = t;
    pause(i, r);
    return (i);
    }

  void QuickSort(int[] a, int l, int r)
    {
    int i;

    if (r > l)
      {
      i = partition(a, l, r);
      if (stopRequested)
	return;
      pause(l,i-1);
      QuickSort(a, l, i-1);
      pause(i+1,r);
      QuickSort(a, i+1, r);
      }
    }

  public override void sort(int[] a)
    {
    QuickSort(a, 0, a.Length-1);
    pause();
    }
  }

