//
// the recursive quicksort algorithm
// Brad Merrill, May 22, 2001
//
using SortControls;

internal class Stack
  {
  private int[] stack;
  private int p;

  public Stack(int max)
    {
    stack = new int[max];
    p = 0;
    }

  public Stack() : this(100) { }
  public void Push(int v) { stack[p++] = v; }
  public int Pop() { return stack[--p]; }
  public bool IsEmpty { get { return (p == 0); } }
  }

internal class QSortStack : SortPanel
  {
  public override string sortAlg { get { return "QuickStacked"; } }
  public override string sortLang { get { return "C#"; } }

  Stack sf = null;

  bool pauseTrue(int i, int j)
    {
    pause(i,j);
    return (true);
    }

  int partition(int[] a, int l, int r)
    {
    int i;
    int j;
    int v;
    int t;

    v = a[r];
    i = l-1;
    j = r;
    for (;;)
      {
      while (i < r && a[++i] <= v && pauseTrue(l,i) && !stopRequested)
	;
      while (j > l && a[--j] >= v && pauseTrue(r,j) && !stopRequested)
	;
      if (stopRequested)
	return (-1);
      if (i >= j)
	break;
      t = a[i];
      a[i] = a[j];
      a[j] = t;
      pause(i, j);
      }
    t = a[i];
    a[i] = a[r];
    a[r] = t;
    pause(i, r);
    return (i);
    }

  void QSortStacked(int[] a, int l, int r)
    {
    int i;

    for (;;)
      {
      while (r > l)
	{
	i = partition(a, l, r);
	if (stopRequested)
	  return;
	if (i-l > r-i)
	  {
	  sf.Push(l);
	  sf.Push(i-1);
	  pause(l,i);
	  l = i+1;
	  }
	else
	  {
	  sf.Push(i+1);
	  sf.Push(r);
	  pause(i,r);
	  r = i-1;
	  }
	}
      if (sf.IsEmpty)
	break;
      r = sf.Pop();
      l = sf.Pop();
      }
    }

  public override void sort(int[] a)
    {
    sf = new Stack(a.Length);
    QSortStacked(a, 0, a.Length-1);
    pause();
    }
  }

