//
// the Shaker sort algorithm
// this is the Sedgewick shellsort algorithm
// 
// Brad Merrill, May 23, 2001
//
using SortControls;

public class ShakerSort : SortPanel
  {
  public override string sortAlg { get { return "Shaker"; } }
  public override string sortLang { get { return "C#"; } }

  public override void sort(int[] a)
    { 
    int i = 0;
    int k = a.Length - 1;
    while (i < k)
      {
      int min = i;
      int max = i;
      for (int j = i + 1; j <= k; j++)
	{
	if (stopRequested)
	  return;
	if (a[j] < a[min])
	  min = j;
	if (a[j] > a[max])
	  max = j;
	pause(i,j);
	}
      int x = a[min];
      a[min] = a[i];
      a[i] = x;
      pause(i,k);

      if (max == i)
	{
	int m = a[min];
	a[min] = a[k];
	a[k] = m;
	}
      else
	{
	int m = a[max];
	a[max] = a[k];
	a[k] = m;
	}
      pause(i,k);
      i++;
      k--;
      }
    }
  }

