//
// the Shellsort algorithm
// this is the Sedgewick shellsort algorithm
// 
// Brad Merrill, May 23, 2001
//
using SortControls;

public class ShellSedgewick : SortPanel
  {
  public override string sortAlg { get { return "ShellSedgewick"; } }
  public override string sortLang { get { return "C#"; } }

  public override void sort(int[] a)
    { 
    int h, t;

    for (t = 1; 4*t*t <= a.Length; t += t)
      ;
    for (h = a.Length/4; t > 0; t /= 2, h = t*t - (3*t)/2 + 1)
      {
      for (int i = h; i < a.Length; i++)
	{ 
	if (stopRequested)
	  return;
	int v = a[i];
	int j = i;
	while (j >= h && v < a[j-h])
	  {
	  if (stopRequested)
	    return;
	  a[j] = a[j-h];
	  pause(i, j);
	  j -= h;
	  }
	a[j] = v; 
	pause(i, j);
	}
      }
    }
  }

