000010* ShellSort implemented in COBOL.
000020 CLASS-ID. SHELLSORT AS "COBOLShellSort" INHERITS SORTPANEL.
000030 ENVIRONMENT DIVISION.
000040 CONFIGURATION SECTION.
000050 REPOSITORY.
000060     CLASS SORTPANEL AS "SortControls.SortPanel"
000070     CLASS INT-ARRAY AS "System.Int32[]"
000080     CLASS SYS-STRING AS "System.String"
000090     PROPERTY LEN AS "Length".
000100 OBJECT.
000110 PROCEDURE DIVISION.
000120 METHOD-ID. GET PROPERTY SORTLANG AS "sortLang" OVERRIDE.
000130 DATA DIVISION.
000140 LINKAGE SECTION.
000150 01 LANG USAGE OBJECT REFERENCE SYS-STRING.
000160 PROCEDURE DIVISION RETURNING LANG.
000170     SET LANG TO "COBOL".
000180 END METHOD.
000190 METHOD-ID. GET PROPERTY SORTALG AS "sortAlg" OVERRIDE.
000200 DATA DIVISION.
000210 LINKAGE SECTION.
000220 01 ALG USAGE OBJECT REFERENCE SYS-STRING.
000230 PROCEDURE DIVISION RETURNING ALG.
000240     SET ALG TO "Shell".
000250 END METHOD.
000260 METHOD-ID. COBOL-SORT AS "sort" OVERRIDE.
000270 DATA DIVISION.
000280 WORKING-STORAGE SECTION.
000290 01 H PIC S9(9) COMP-5.
000300 01 I PIC S9(9) COMP-5.
000310 01 J PIC S9(9) COMP-5.
000320 01 V PIC S9(9) COMP-5.
000330 01 DJH PIC S9(9) COMP-5.
000340 01 WK PIC S9(9) COMP-5.
000350 01 VAL PIC S9(9) COMP-5.
000360 01 S PIC 1.
000370 LINKAGE SECTION.
000380 01 A OBJECT REFERENCE INT-ARRAY.
000390 PROCEDURE DIVISION USING BY VALUE A.
000400     MOVE 1 TO H
000410     PERFORM UNTIL H > LEN OF A / 9
000420         COMPUTE H = 3 * H + 1
000430     END-PERFORM.
000440     
000450     PERFORM UNTIL H <= 0
000460         COMPUTE I = H + 1
000470         PERFORM UNTIL I >= LEN OF A
000480             SET S TO stopRequested OF SELF 
000490             IF S = B"1" THEN
000500                 EXIT METHOD
000510             END-IF
000520             INVOKE A "Get" USING BY VALUE I RETURNING V
000530             MOVE I TO J
000540             PERFORM WITH NO LIMIT
000550                 COMPUTE DJH = J - H
000560                 IF J <= H THEN
000570                     EXIT PERFORM
000580                 END-IF
000590                 IF A::"Get"(DJH) <= V THEN
000600                     EXIT PERFORM
000610                 END-IF
000620                 INVOKE A "Get" USING BY VALUE DJH RETURNING VAL
000630                 INVOKE A "Set" USING BY VALUE J VAL
000640                 INVOKE SELF "pause" USING BY VALUE I J
000650                 MOVE DJH TO J
000660             END-PERFORM
000670             INVOKE A "Set" USING BY VALUE J V
000680             INVOKE SELF "pause" USING BY VALUE I J
000690             ADD 1 TO I
000700         END-PERFORM
000710         COMPUTE H = H / 3
000720     END-PERFORM.
000730     
000740     MOVE 1 TO I
000750     COMPUTE J = LEN OF A - 1
000760     INVOKE A "Get" USING BY VALUE 0 RETURNING V
000770     PERFORM UNTIL J <= I
000780         COMPUTE H = (I + J) / 2
000790         IF V < A::"Get"(H) THEN
000800             COMPUTE J = H - 1
000810         ELSE
000820             COMPUTE I = H + 1
000830         END-IF
000840         INVOKE SELF "pause" USING BY VALUE I J
000850     END-PERFORM
000860     
000870     PERFORM VARYING I FROM 0 BY 1 UNTIL I >= J
000880         COMPUTE WK = I + 1
000890         INVOKE A "Get" USING BY VALUE WK RETURNING VAL
000900         INVOKE A "Set" USING BY VALUE I VAL
000910     END-PERFORM
000920     
000930     IF  A::"Get"(J) > V THEN
000940         COMPUTE WK = J - 1
000950         INVOKE A "Set" USING BY VALUE WK V
000960     ELSE
000970         INVOKE A "Set" USING BY VALUE J V
000980     END-IF
000990     
001000     INVOKE SELF "pause".
001010 END METHOD COBOL-SORT.
001020 END OBJECT.
001030 END CLASS SHELLSORT.
