//
// the Shellsort algorithm
// an aspect of shell sort is that it cannot sort element 0, so we have to
// do either an insertion sort of 1 item, or a binary search for position,
// and then insert into position
// 
// Brad Merrill, Mar 14, 2001
//
using SortControls;

public class ShellSort : SortPanel
  {
  public override string sortAlg { get { return "Shell"; } }
  public override string sortLang { get { return "C#"; } }

  public override void sort(int[] a)
    {
    int h;
    int i;
    int j;
    int v;
    int djh;

    for (h = 1; h <= a.Length/9; h = 3*h+1)
      ;

    for ( ; h > 0; h /= 3)
      {
      for (i = h+1; i < a.Length; i++)
	{
	if (stopRequested)
	  return;
	v = a[i];
	j = i;
	while(true)
	  {
	  djh = j-h;
	  if (j <= h)
	    break;
	  if (a[djh] <= v)
	    break;
	  a[j] = a[djh];
	  pause(i, j);
	  j = djh;
	  }
	a[j] = v;
	pause(i, j);
	}
      }

    /*
     * this implements a binary search followed by moving all elements less
     * than insertion element down
     */
    i = 1;
    j = a.Length-1;
    v = a[0];
    while (j > i)
      {
      h = (i+j)/2;
      if (v < a[h])
	{
	j = h-1 ;
	}
      else
	{
	i = h+1;
	}
      pause(i,j);
      }
    for (i = 0; i < j; i++)
      {
      a[i] = a[i+1];
      }
    if (a[j] > v)
      a[j-1] = v;
    else
      a[j] = v;
    pause();
    }

}
