000010 CLASS-ID. REMINDER INHERITS FORM.
000020 ENVIRONMENT DIVISION.
000030 CONFIGURATION SECTION.
000040 REPOSITORY.
000050     CLASS FORM AS "System.Windows.Forms.Form"
000060     CLASS WALK
000070     CLASS WIN-LABEL AS "System.Windows.Forms.Label"
000080     CLASS BUTTON AS "System.Windows.Forms.Button"
000090     CLASS PICTUREBOX AS "System.Windows.Forms.PictureBox"
000100     CLASS CONTAINER AS "System.ComponentModel.Container"
000101     CLASS APPLICATION AS "System.Windows.Forms.Application"
000110     DELEGATE EVENTHANDLER AS "System.EventHandler"
000120     DELEGATE CANCEL-EVENTHANDLER AS "System.ComponentModel.CancelEventHandler"
000130     CLASS CANCEL-EVENTARGS AS "System.ComponentModel.CancelEventArgs"
000140     CLASS EVENTARGS AS "System.EventArgs"
000150     CLASS POINT AS "System.Drawing.Point"
000160     CLASS DRAWING-SIZE AS "System.Drawing.Size"
000170     CLASS FONT AS "System.Drawing.Font"
000180     CLASS IMAGE AS "System.Drawing.Image"
000190     CLASS PATH AS "System.IO.Path"
000200     CLASS SYS-OBJECT AS "System.Object"
000210     CLASS SYS-STRING AS "System.String"
000211     CLASS SYS-BOOLEAN AS "System.Boolean"
000220     CLASS SYS-RANDOM AS "System.Random"
000230     CLASS CONTROL-COLLECTION AS "System.Windows.Forms.Control+ControlCollection"
000240     PROPERTY PROP-LOCATION AS "Location"
000250     PROPERTY PROP-SIZE AS "Size"
000260     PROPERTY PROP-TABINDEX AS "TabIndex"
000270     PROPERTY PROP-TEXT AS "Text"
000280     PROPERTY PROP-TEXT-ALIGN AS "TextAlign"
000290     ENUM CONTENT-ALIGNMENT AS "System.Drawing.ContentAlignment"
000300     PROPERTY PROP-MIDDLE-CENTER AS "MiddleCenter"
000310     PROPERTY PROP-FONT AS "Font"
000320     ENUM FONT-STYLE AS "System.Drawing.FontStyle"
000330     PROPERTY PROP-BOLD AS "Bold"
000340     PROPERTY APP-CONTROLS AS "Controls"
000350     PROPERTY PROP-TABSTOP AS "TabStop"
000360     PROPERTY PROP-AUTOSCALEBASESIZE AS "AutoScaleBaseSize"
000370     PROPERTY PROP-CLIENT-SIZE AS "ClientSize"
000380     PROPERTY PROP-EXECUTABLE-PATH AS "ExecutablePath"
000390     ENUM PICTUREBOX-SIZEMODE AS "System.Windows.Forms.PictureBoxSizeMode"
000391     PROPERTY PROP-SIZE-MODE AS "SizeMode"
000400     PROPERTY PROP-CENTER-IMAGE AS "CenterImage"
000410     PROPERTY PROP-IMAGE AS "Image"
000420     PROPERTY PROP-FORM-BORDER-STYLE AS "FormBorderStyle"
000430     ENUM FORM-BORDER-STYLE AS "System.Windows.Forms.FormBorderStyle"
000440     PROPERTY PROP-FIXED-DIALOG AS "FixedDialog"
000441     PROPERTY PROP-CONTROL-BOX AS "ControlBox"
000450     PROPERTY PROP-MAXIMIZE-BOX AS "MaximizeBox"
000460     PROPERTY PROP-MINIMIZE-BOX AS "MinimizeBox".
000470 OBJECT.
000480 DATA DIVISION.
000490 WORKING-STORAGE SECTION.
000500 01 COMPONENTS OBJECT REFERENCE CONTAINER.
000510 01 LABEL1 OBJECT REFERENCE WIN-LABEL.
000520 01 OK-BUTTON OBJECT REFERENCE BUTTON.
000530 01 NOT-NOW-BUTTON OBJECT REFERENCE BUTTON.
000540 01 PICTUREBOX1 OBJECT REFERENCE PICTUREBOX.
000550 01 SAVED-OWNER OBJECT REFERENCE WALK.
000560 01 BUTTON-CLICKED PIC 1 USAGE BIT.
000561 01 RAND OBJECT REFERENCE SYS-RANDOM.
000570 PROCEDURE DIVISION.
000580 METHOD-ID. NEW.
000590 DATA DIVISION.
000600 WORKING-STORAGE SECTION.
000610 01 MESSAGES.
000620    03  PIC X(30) VALUE 'Let me in!'.
000630    03  PIC X(30) VALUE 'Play ball with me!'.
000640    03  PIC X(30) VALUE 'Let me out!'.
000650    03  PIC X(30) VALUE 'Feed me!'.
000660    03  PIC X(30) VALUE 'Play frisbee with me!'.
000670    03  PIC X(30) VALUE 'Play with me!'.
000680    03  PIC X(30) VALUE 'Take me for a walk!'.
000690    03  PIC X(30) VALUE 'Clip my claws!'.
000700 01 MESSAGE-TABLE REDEFINES MESSAGES.
000710    03 MESSAGE-ITEM OCCURS 8 TIMES.
000720        05 DOG-MESSAGE PIC X(30).
000730 01 IMAGE-FILES.
000740    03  PIC X(20) VALUE 'LET-ME-IN.JPG'.
000750    03  PIC X(20) VALUE 'PLAY-BALL.JPG'.
000760    03  PIC X(20) VALUE 'LET-ME-OUT.JPG'.
000770    03  PIC X(20) VALUE 'FEED-ME.JPG'.
000780    03  PIC X(20) VALUE 'PLAY-FRISBEE.JPG'.
000790    03  PIC X(20) VALUE 'PLAY.JPG'.
000800    03  PIC X(20) VALUE 'WALK.JPG'.
000810    03  PIC X(20) VALUE 'CLIP-CLAWS.JPG'.
000820 01 IMAGE-TABLE REDEFINES IMAGE-FILES.
000830    03 IMAGES OCCURS 8 TIMES.
000840        05 IMAGE-FILE PIC X(20).
000850 01 MAX-REMINDERS PIC 9(4) COMP-5 VALUE 8.
000870 01 NEXT-NUM PIC S9(9) COMP-5.
000880 01 APP-PATH OBJECT REFERENCE SYS-STRING.
000890 01 IMAGE-PATH OBJECT REFERENCE SYS-STRING.
000900 LINKAGE SECTION.
000910 01 WALK-OWNER OBJECT REFERENCE WALK.
000920 PROCEDURE DIVISION USING BY VALUE WALK-OWNER.
000930     SET SAVED-OWNER TO WALK-OWNER.
000940     INVOKE SELF "InitializeComponent".
000941	   IF RAND = NULL THEN
000950         INVOKE SYS-RANDOM "NEW" RETURNING RAND
000951     END-IF.
000960     INVOKE RAND "Next" USING BY VALUE MAX-REMINDERS RETURNING NEXT-NUM.
000970     ADD 1 TO NEXT-NUM.
000980     SET PROP-TEXT OF LABEL1 TO DOG-MESSAGE(NEXT-NUM).
000990     SET APP-PATH TO PROP-EXECUTABLE-PATH OF APPLICATION.
001000     INVOKE PATH "GetDirectoryName" USING BY VALUE APP-PATH
001010         RETURNING APP-PATH.
001020     SET IMAGE-PATH TO PATH::"Combine"(APP-PATH, IMAGE-FILE(NEXT-NUM)).
001030     SET PROP-IMAGE OF PICTUREBOX1 TO IMAGE::"FromFile"(IMAGE-PATH).
001040 END METHOD NEW.
001050* 
001060 METHOD-ID. DISPOSE AS "Dispose" PROTECTED OVERRIDE.
001070 DATA DIVISION.
001080 WORKING-STORAGE SECTION.
001090 01 FLAG PIC 1 USAGE BIT.
001100 LINKAGE SECTION.
001110 01 DISPOSING OBJECT REFERENCE SYS-BOOLEAN.
001120 PROCEDURE DIVISION USING BY VALUE DISPOSING.
001130     SET FLAG TO DISPOSING.
001140     IF FLAG = B"1" AND COMPONENTS NOT = NULL THEN
001150         INVOKE COMPONENTS "Dispose"
001160     END-IF.
001170     INVOKE SUPER "Dispose" USING BY VALUE DISPOSING.
001180 END METHOD DISPOSE.
001190* 
001200 METHOD-ID. INITIALIZECOMPONENT AS "InitializeComponent".
001210 DATA DIVISION.
001220 WORKING-STORAGE SECTION.
001230 01 BOLD-FONT OBJECT REFERENCE FONT-STYLE.
001240 01 OK-EVENT OBJECT REFERENCE EVENTHANDLER.
001250 01 NOT-NOW-EVENT OBJECT REFERENCE EVENTHANDLER.
001260 01 CLOSING-EVENT OBJECT REFERENCE CANCEL-EVENTHANDLER.
001270 PROCEDURE DIVISION.
001280     INVOKE WIN-LABEL "NEW" RETURNING LABEL1.
001290     INVOKE BUTTON "NEW" RETURNING OK-BUTTON.
001300     INVOKE BUTTON "NEW" RETURNING NOT-NOW-BUTTON.
001310     INVOKE PICTUREBOX "NEW" RETURNING PICTUREBOX1.
001320     INVOKE SELF "SuspendLayout".
001330*
001340     SET PROP-LOCATION OF LABEL1 TO POINT::"NEW" (24, 224).
001350     SET PROP-SIZE OF LABEL1 TO DRAWING-SIZE::"NEW" (312, 32).
001360     SET PROP-TEXT-ALIGN OF LABEL1 TO
001370         PROP-MIDDLE-CENTER OF CONTENT-ALIGNMENT.
001380     SET BOLD-FONT TO PROP-BOLD OF FONT-STYLE.
001390     SET PROP-FONT OF LABEL1 TO
001400         FONT::"NEW" ("Microsoft Sans Serif", 12.0, BOLD-FONT).
001410     INVOKE APP-CONTROLS OF SELF "Add" USING BY VALUE LABEL1.
001420*
001430     SET PROP-LOCATION OF OK-BUTTON TO POINT::"NEW" (48, 272).
001440     SET PROP-SIZE OF OK-BUTTON TO DRAWING-SIZE::"NEW" (75, 32).
001450     SET PROP-TEXT OF OK-BUTTON TO "&OK".
001460     INVOKE EVENTHANDLER "NEW" USING BY VALUE SELF "OK_Click"
001470         RETURNING OK-EVENT.
001480     INVOKE OK-BUTTON "add_Click" USING BY VALUE OK-EVENT.
001490     INVOKE APP-CONTROLS OF SELF "Add" USING BY VALUE OK-BUTTON.
001500*
001510     SET PROP-LOCATION OF NOT-NOW-BUTTON TO POINT::"NEW" (200, 272).
001520     SET PROP-SIZE OF NOT-NOW-BUTTON TO DRAWING-SIZE::"NEW" (96, 32).
001530     SET PROP-TEXT OF NOT-NOW-BUTTON TO "&Not now".
001540     INVOKE EVENTHANDLER "NEW" USING BY VALUE SELF "Not_Now_Click"
001550         RETURNING NOT-NOW-EVENT.
001560     INVOKE NOT-NOW-BUTTON "add_Click" USING BY VALUE NOT-NOW-EVENT.
001570     INVOKE APP-CONTROLS OF SELF "Add" USING BY VALUE NOT-NOW-BUTTON.
001580*
001590     SET PROP-LOCATION OF PICTUREBOX1 TO POINT::"NEW"(24, 16).
001600     SET PROP-SIZE OF PICTUREBOX1 TO DRAWING-SIZE::"NEW"(312, 192).
001610     SET PROP-SIZE-MODE OF PICTUREBOX1 TO PROP-CENTER-IMAGE OF PICTUREBOX-SIZEMODE.
001620     SET PROP-TABSTOP OF PICTUREBOX1 TO B"0".
001630     INVOKE APP-CONTROLS OF SELF "Add" USING BY VALUE PICTUREBOX1.
001640* 
001650     SET PROP-TEXT OF SELF TO "Doggy Reminder".
001660     SET PROP-AUTOSCALEBASESIZE OF SELF TO DRAWING-SIZE::"NEW" (8, 19).
001670     SET PROP-CLIENT-SIZE OF SELF TO DRAWING-SIZE::"NEW" (360, 325).
001680     SET PROP-CONTROL-BOX OF SELF TO B"0".
001690     SET PROP-FONT OF SELF TO
001700         FONT::"NEW" ("Microsoft Sans Serif", 12.0, BOLD-FONT).
001710     SET PROP-FORM-BORDER-STYLE OF SELF TO PROP-FIXED-DIALOG OF FORM-BORDER-STYLE.
001720     SET PROP-MAXIMIZE-BOX OF SELF TO B"0".
001730     SET PROP-MINIMIZE-BOX OF SELF TO B"0".
001740     INVOKE CANCEL-EVENTHANDLER "NEW" USING BY VALUE SELF "Reminder_Closing"
001750         RETURNING CLOSING-EVENT.
001760     INVOKE SELF "add_Closing" USING BY VALUE CLOSING-EVENT.
001770     
001780     INVOKE SELF "ResumeLayout" USING BY VALUE B'0'.
001790 END METHOD INITIALIZECOMPONENT.
001800* 
001810 METHOD-ID. OK_CLICK AS "OK_Click".
001820 DATA DIVISION.
001830 WORKING-STORAGE SECTION.
001840 01 DISPOSING OBJECT REFERENCE SYS-BOOLEAN.
001850 LINKAGE SECTION.
001860 01 SENDER OBJECT REFERENCE SYS-OBJECT.
001870 01 E OBJECT REFERENCE EVENTARGS.
001880 PROCEDURE DIVISION USING BY VALUE SENDER E.
001890     INVOKE SAVED-OWNER "RESET-TIMER".
001900     MOVE B"1" TO BUTTON-CLICKED.
001910     SET DISPOSING TO B"1".
001920     INVOKE SELF "Dispose" USING BY VALUE DISPOSING.
001930 END METHOD OK_CLICK.
001940* 
001950 METHOD-ID. NOT_NOW_CLICK AS "Not_Now_Click".
001960 DATA DIVISION.
001970 WORKING-STORAGE SECTION.
001980 01 DISPOSING OBJECT REFERENCE SYS-BOOLEAN.
001990 LINKAGE SECTION.
002000 01 SENDER OBJECT REFERENCE SYS-OBJECT.
002010 01 E OBJECT REFERENCE EVENTARGS.
002020 PROCEDURE DIVISION USING BY VALUE SENDER E.
002030     INVOKE SAVED-OWNER "DECREMENT-TIMER".
002040     MOVE B"1" TO BUTTON-CLICKED.
002050     SET DISPOSING TO B"1".
002060     INVOKE SELF "Dispose" USING BY VALUE DISPOSING.
002070 END METHOD NOT_NOW_CLICK.
002080* 
002090 METHOD-ID. REMINDER_CLOSING AS "Reminder_Closing".
002100 DATA DIVISION.
002110 LINKAGE SECTION.
002120 01 SENDER OBJECT REFERENCE SYS-OBJECT.
002130 01 E OBJECT REFERENCE CANCEL-EVENTARGS.
002140 PROCEDURE DIVISION USING BY VALUE SENDER E.
002150     IF BUTTON-CLICKED = B"0" THEN
002160         INVOKE SAVED-OWNER "DECREMENT-TIMER"
002170     END-IF.
002180     MOVE B"0" TO BUTTON-CLICKED.
002190 END METHOD REMINDER_CLOSING.
002200* 
002210 END OBJECT.
002220 END CLASS REMINDER.
002230