
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Text.RegularExpressions" %>

<script language=C# runat=server>
        
    public String FontSize = "10";
    public String FileName;
        
    const string TAG_FNTRED  = "<font color= \"red\">";
    const string TAG_FNTBLUE = "<font color= \"blue\">" ;
    const string TAG_FNTGRN  = "<font color= \"green\">" ;
    const string TAG_FNTMRN  = "<font color=\"maroon\">" ;
    const string TAG_EFONT   = "</font>" ;

    void Page_Load(Object sender, EventArgs e) {
	
        FileStream  file        = null;         
        string      sourceLine  = null;
        bool        isCOBOLCode    = false;   
        bool        isHtmlCode  = false;
	bool	    isCSCode	= false;
	bool	    isJSCode	= false;
	bool	    isVBCode	= false;
                       		
        if((FileName.ToLower()).EndsWith(".htm"))
            isHtmlCode = true;
        if((FileName.ToLower()).EndsWith(".cob"))
            isCOBOLCode = true;
        if((FileName.ToLower()).EndsWith(".cs"))
            isCSCode = true;
        if((FileName.ToLower()).EndsWith(".js"))
            isJSCode = true;
        if((FileName.ToLower()).EndsWith(".vb"))
            isVBCode = true;

        try {
        
            file = new FileStream(FileName, FileMode.Open, FileAccess.Read, FileShare.Read);
            StreamReader sr = new StreamReader(file);
            StringWriter textBuffer = new StringWriter(); 

            if (isHtmlCode == true) {
            
                while((sourceLine = sr.ReadLine()) != null) {
                    textBuffer.Write(sourceLine) ;
                    textBuffer.Write("\r\n");
                }
            }
            else if (isCOBOLCode == true) {
                textBuffer.Write("<pre>\r\n");
                while((sourceLine = sr.ReadLine()) != null) {
                    textBuffer.Write(FixCOBOLLine(sourceLine)) ;
                    textBuffer.Write("\r\n");
                }
                textBuffer.Write("</pre>");
            }
            else if (isCSCode == true) {
                textBuffer.Write("<pre>\r\n");
                while((sourceLine = sr.ReadLine()) != null) {
                    textBuffer.Write(FixCSLine(sourceLine)) ;
                    textBuffer.Write("\r\n");
                }
                textBuffer.Write("</pre>");
            }
            else if (isJSCode == true) {
                textBuffer.Write("<pre>\r\n");
                while((sourceLine = sr.ReadLine()) != null) {
                    textBuffer.Write(FixJSLine(sourceLine)) ;
                    textBuffer.Write("\r\n");
                }
                textBuffer.Write("</pre>");
            }
            else if (isVBCode == true) {
                textBuffer.Write("<pre>\r\n");
                while((sourceLine = sr.ReadLine()) != null) {
                    textBuffer.Write(FixVBLine(sourceLine)) ;
                    textBuffer.Write("\r\n");
                }
                textBuffer.Write("</pre>");
            }
            else {
           
                textBuffer.Write("<pre>\r\n");
           
                string lang = "VB";
                bool isInScriptBlock = false;
                bool isInMultiLine = false;
           
                while((sourceLine = sr.ReadLine()) != null) {
                    // First we want to grab the global language
                    // for this page by a Page directive.  Or
                    // possibly from a script block.
                    lang = GetLangFromLine(sourceLine, lang); 
                    if (IsScriptBlockTagStart(sourceLine)) {
                        textBuffer.Write(FixAspxLine(sourceLine));
                        isInScriptBlock = true;
                    }
                    else if (IsScriptBlockTagEnd(sourceLine)) {
                        textBuffer.Write(FixAspxLine(sourceLine));
                        isInScriptBlock = false;
                    }
                    else if (IsMultiLineTagStart(sourceLine) && !isInMultiLine) {
                        isInMultiLine = true;
                        textBuffer.Write("<font color=blue><b>" + HttpUtility.HtmlEncode(sourceLine));
                    }
                    else if (IsMultiLineTagEnd(sourceLine) && isInMultiLine) {
                        isInMultiLine = false;
                        textBuffer.Write(HttpUtility.HtmlEncode(sourceLine) + "</b></font>");
                    }
                    else if (isInMultiLine) {
                        textBuffer.Write(HttpUtility.HtmlEncode(sourceLine));
                    }
                    else {
                        if (isInScriptBlock == true) {
                            if (lang.ToLower() == "cobol") {
                                textBuffer.Write(FixCOBOLLine(sourceLine));
                            } else if (lang.ToLower() == "vb") {
                                textBuffer.Write(FixVBLine(sourceLine));
                            } else if (lang.ToLower() == "c#") {
                                textBuffer.Write(FixCSLine(sourceLine));
                            } else if (lang.ToLower() == "jscript" || lang.ToLower() == "javascript") {
                                textBuffer.Write(FixJSLine(sourceLine));
                            }
                        }
                        else {
                            textBuffer.Write(FixAspxLine(sourceLine));
                        }
                    }
                
                    textBuffer.Write("\r\n");
                }
                
                textBuffer.Write("</pre>");
            }
                
            sourcePanel.Controls.Add(new LiteralControl(textBuffer.ToString()) );
        }
        catch(Exception err) {
            sourcePanel.Controls.Add(new LiteralControl(string.Concat("Error displaying source...<br>", e.ToString()) ));
        }
        finally {
	        if (file!=null) {
                file.Close();
            }
        }
				
        sourcePanel.Style["font-size"] = FontSize;
    }

bool IsScriptBlockTagStart(String source) {
    if (Regex.IsMatch(source, "<script.*runat=\"?server\"?.*>")) {
        return true;
    }
    if (Regex.IsMatch(source, "(?i)<%@\\s*WebService")) {
        return true;
    }
    return false;
} 

bool IsScriptBlockTagEnd(String source) {
    if (Regex.IsMatch(source, "</script.*>")) {
        return true;
    }
    return false;
}
            
bool IsMultiLineTagStart(String source) {
    String searchExpr = "(?i)(?!.*&gt;)(?<a>&lt;/?)(?<b>(asp:|template|property|IBuySpy:).*)";

    source = HttpUtility.HtmlEncode(source);
    if ( Regex.IsMatch(source, searchExpr) ) {
        return true;
    }
    return false;
}

bool IsMultiLineTagEnd(String source) {
    String searchExpr = "(?i)&gt;";

    source = HttpUtility.HtmlEncode(source);
    if ( Regex.IsMatch(source, searchExpr) ) {
        return true;
    }
    return false;
}

string GetLangFromLine(string sourceLine, string defLang) {
    if ( sourceLine == null ) {
        return defLang;
    }

    Match langMatch = Regex.Match(sourceLine, "(?i)<%@\\s*Page\\s*.*Language\\s*=\\s*\"(?<lang>[^\"]+)\"");
    if ( langMatch.Success ) {
        return langMatch.Groups["lang"].ToString();
    }

    langMatch = Regex.Match(sourceLine, "(?i)(?=.*runat\\s*=\\s*\"?server\"?)<script.*language\\s*=\\s*\"(?<lang>[^\"]+)\".*>");
    if ( langMatch.Success ) {
        return langMatch.Groups["lang"].ToString();
    }

    langMatch = Regex.Match(sourceLine, "(?i)<%@\\s*WebService\\s*.*Language\\s*=\\s*\"?(?<lang>[^\"]+)\"?");
    if ( langMatch.Success ) {
        return langMatch.Groups["lang"].ToString();
    }

    return defLang;
}

    string FixCOBOLLine(string sourceLine) {
    
        string searchExpr;  // search string
        string replaceExpr; // replace string

        if (sourceLine == null)
            return null;

	// Substitute brackets
	sourceLine = Regex.Replace(sourceLine, "<", "&lt;");
	sourceLine = Regex.Replace(sourceLine, ">", "&gt;");

        // Colorize comments
        searchExpr = "(?<=^.{6})(?<x>(\\*.*))" ;
        replaceExpr = TAG_FNTGRN + "${x}" + TAG_EFONT ;
				
        if (Regex.IsMatch(sourceLine, searchExpr) ) {
            return Regex.Replace(sourceLine, searchExpr, replaceExpr);
        }

        searchExpr = "(?<x>(\\*&gt;.*))" ;
        replaceExpr = TAG_FNTGRN + "${x}" + TAG_EFONT ;
				
        if (Regex.IsMatch(sourceLine, searchExpr) ) {
            return Regex.Replace(sourceLine, searchExpr, replaceExpr);
        }

        // Colorize level numbers.		
          searchExpr = "(?i)(?<=^.{7,10})(?<x>(01|02|03|77|88))(?=\\s)";
          replaceExpr = TAG_FNTRED + "${x}" + TAG_EFONT;
          
          if (Regex.IsMatch(sourceLine, searchExpr)) {
              sourceLine = Regex.Replace(sourceLine, searchExpr, replaceExpr);
          }
        
        // Colorize special language constructs.		
          searchExpr = "(?i)(?<=(\\s|^))(?<x>(ACCESS|ADD|ALTERNATE|AS|ASSIGN|BY|CALL|CLASS-ID|CLASS|CLOSE|COMPUTE|COMP-5|CONFIGURATION|CONTINUE|CUSTOM-ATTRIBUTE|DATA|DELEGATE-ID|DELEGATE|DISPLAY|DIVIDE|DIVISION|DUPLICATES|ELSE|END-IF|END-PERFORM|END-READ|END|ENUM|ENVIRONMENT|EQUALS|EQUAL|EVALUATE|EXCEPTION|EXIT|FD|FILE-CONTROL|FILE|GO|IDENTIFICATION|IF|INDEXED|INHERITS|INPUT-OUTPUT|INTERFACE|INVOKE|I-O-CONTROL|I-O|IS|KEY|LENGTH|LINKAGE|METHOD-ID|METHOD|MODE|MOVE|MULTIPLY|NOT|NULL|NUMERIC|OBJECT|OCCURS|OF|OPEN|ORGANIZATION|OVERRIDE|PERFORM|PICTURE|PIC|POINTER|PROCEDURE|PROGRAM|PROGRAM-ID|PROGRAM-POINTER|PROPERTY|PROTOTYPE|PUBLIC|RAISE|RAISING|READ|RECORD|REFERENCE|REPOSITORY|RETURNING|SECTION|SELECT|SEQUENTIAL|SET|SPECIAL-NAMES|STATIC|STOP|THEN|TO|UNTIL|USAGE|USING|VALUE|VARYING|WITH|WORKING-STORAGE))\\b(?=([^-]|$))";
          replaceExpr = TAG_FNTBLUE + "${x}" + TAG_EFONT;
          
          if (Regex.IsMatch(sourceLine, searchExpr)) {
              sourceLine = Regex.Replace(sourceLine, searchExpr, replaceExpr);
          }

	return sourceLine;
    }

string FixAspxLine(string sourceLine ) {
    string searchExpr;      // search string
    string replaceExpr;     // replace string

    if ((sourceLine == null) || (sourceLine.Length == 0))
        return sourceLine;

    // Search for \t and replace it with 4 spaces.
    sourceLine = Regex.Replace(sourceLine, "(?i)(\\t)", "    ");
    sourceLine = HttpUtility.HtmlEncode(sourceLine);


    // Single line comment or #include references.
    searchExpr = "(?i)(?<a>(^.*))(?<b>(&lt;!--))(?<c>(.*))(?<d>(--&gt;))(?<e>(.*))";
    replaceExpr = "${a}" + TAG_FNTGRN + "${b}${c}${d}" + TAG_EFONT + "${e}";

    if (Regex.IsMatch(sourceLine, searchExpr))
        return Regex.Replace(sourceLine, searchExpr, replaceExpr);

    // Colorize <%@ <type>
    searchExpr = "(?i)" + "(?<a>(&lt;%@))" + "(?<b>(.*))" + "(?<c>(%&gt;))";
    replaceExpr = "<font color=blue><b>${a}${b}${c}</b></font>";

    if (Regex.IsMatch(sourceLine, searchExpr))
        sourceLine = Regex.Replace(sourceLine, searchExpr, replaceExpr);

    // Colorize <%# <type>
    searchExpr = "(?i)" + "(?<a>(&lt;%#))" + "(?<b>(.*))" + "(?<c>(%&gt;))";
    replaceExpr = "${a}" + "<font color=red><b>" + "${b}" + "</b></font>" + "${c}";

    if (Regex.IsMatch(sourceLine, searchExpr))
        sourceLine = Regex.Replace(sourceLine, searchExpr, replaceExpr);

    // Colorize tag <type>
    searchExpr = "(?i)" + "(?<a>(&lt;)(?!%)(?!/?asp:)(?!/?template)(?!/?property)(?!/?ibuyspy:)(/|!)?)" + "(?<b>[^;\\s&]+)" + "(?<c>(\\s|&gt;|\\Z))";
    replaceExpr = "${a}" + TAG_FNTMRN + "${b}" + TAG_EFONT + "${c}";

    if (Regex.IsMatch(sourceLine, searchExpr))
        sourceLine = Regex.Replace(sourceLine, searchExpr, replaceExpr);

    // Colorize asp:|template for runat=server tags <type>
    searchExpr = "(?i)(?<a>&lt;/?)(?<b>(asp:|template|property|IBuySpy:).*)(?<c>&gt;)?";
    replaceExpr = "${a}<font color=blue><b>${b}</b></font>${c}";

    if (Regex.IsMatch(sourceLine, searchExpr))
        sourceLine = Regex.Replace(sourceLine, searchExpr, replaceExpr);

    //colorize begin of tag char(s) "<","</","<%"
    searchExpr = "(?i)(?<a>(&lt;)(/|!|%)?)";
    replaceExpr = TAG_FNTBLUE + "${a}" + TAG_EFONT;

	if (Regex.IsMatch(sourceLine, searchExpr))
        sourceLine = Regex.Replace(sourceLine, searchExpr, replaceExpr);

    // Colorize end of tag char(s) ">","/>"
    searchExpr = "(?i)(?<a>(/|%)?(&gt;))";
    replaceExpr = TAG_FNTBLUE + "${a}" + TAG_EFONT;

    if (Regex.IsMatch(sourceLine, searchExpr))
        sourceLine = Regex.Replace(sourceLine, searchExpr, replaceExpr);

    return sourceLine;
}

string FixCSLine(string sourceLine) {
    if (sourceLine == null)
        return null;

    sourceLine = Regex.Replace(sourceLine, "(?i)(\\t)", "    ");
    sourceLine = HttpUtility.HtmlEncode(sourceLine);

    String[] keywords = new String[]
        {"private", "protected", "public", "namespace", "class", "break",
         "for", "if", "else", "while", "switch", "case", "using",
         "return", "null", "void", "int", "bool", "string", "float",
         "this", "new", "true", "false", "const", "static", "base",
         "foreach", "in", "try", "catch", "get", "set", "char", "default"};

    String CombinedKeywords = "(?<keyword>" + String.Join("|", keywords) + ")";

    sourceLine = Regex.Replace(sourceLine, "\\b" + CombinedKeywords + "\\b(?<!//.*)", TAG_FNTBLUE + "${keyword}" + TAG_EFONT);
    sourceLine = Regex.Replace(sourceLine, "(?<comment>//.*$)", TAG_FNTGRN + "${comment}" + TAG_EFONT);

    return sourceLine;
}

string FixJSLine(string sourceLine) {
    if (sourceLine == null)
        return null;

    sourceLine = Regex.Replace(sourceLine, "(?i)(\\t)", "    ");
    sourceLine = HttpUtility.HtmlEncode(sourceLine);

    String[] keywords = new String[]
        {"private", "protected", "public", "namespace", "class", "var",
         "for", "if", "else", "while", "switch", "case", "using", "get",
         "return", "null", "void", "int", "string", "float", "this", "set",
         "new", "true", "false", "const", "static", "package", "function",
         "internal", "extends", "super", "import", "default", "break", "try",
         "catch", "finally" };

    String CombinedKeywords = "(?<keyword>" + String.Join("|", keywords) + ")";

    sourceLine = Regex.Replace(sourceLine, "\\b" + CombinedKeywords + "\\b(?<!//.*)", TAG_FNTBLUE + "${keyword}" + TAG_EFONT);
    sourceLine = Regex.Replace(sourceLine, "(?<comment>//.*$)", TAG_FNTGRN + "${comment}" + TAG_EFONT);

    return sourceLine;
}

string FixVBLine(string sourceLine) {
    if (sourceLine == null)
        return null;

    sourceLine = Regex.Replace(sourceLine, "(?i)(\\t)", "    ");
    sourceLine = HttpUtility.HtmlEncode(sourceLine);

    String[] keywords = new String[]
        {"Private", "Protected", "Public", "End Namespace", "Namespace",
         "End Class", "Exit", "Class", "Goto", "Try", "Catch", "End Try",
         "For", "End If", "If", "Else", "ElseIf", "Next", "While", "And",
         "Do", "Loop", "Dim", "As", "End Select", "Select", "Case", "Or",
         "Imports", "Then", "Integer", "Long", "String", "Overloads", "True",
         "Overrides", "End Property", "End Sub", "End Function", "Sub", "Me",
         "Function", "End Get", "End Set", "Get", "Friend", "Inherits",
         "Implements","Return", "Not", "New", "Shared", "Nothing", "Finally",
         "False", "Me", "My", "MyBase" };


    String CombinedKeywords = "(?<keyword>" + String.Join("|", keywords) + ")";

    sourceLine = Regex.Replace(sourceLine, "(?i)\\b" + CombinedKeywords + "\\b(?<!'.*)", TAG_FNTBLUE + "${keyword}" + TAG_EFONT);
    sourceLine = Regex.Replace(sourceLine, "(?<comment>'(?![^']*&quot;).*$)", TAG_FNTGRN + "${comment}" + TAG_EFONT);

    return sourceLine;
}

</script>

<asp:panel id="sourcePanel" runat=server/>




