000010*=================================================================
000020*  Compute the total days from 1/1/1900
000030*=================================================================
000040 IDENTIFICATION DIVISION.
000050   PROGRAM-ID. SUMCALC  INITIAL PROGRAM.
000060*
000070 DATA DIVISION.
000080 WORKING-STORAGE SECTION.
000090   77  TOTAL-DAYS  PIC S9(8) BINARY.
000100   77  CTR         PIC S9(4) BINARY.
000110   77  LEAP-YEAR   PIC S9(8) BINARY.
000120   77  WORK-YEAR   PIC S9(4) BINARY.
000130   77  REM1        PIC S9(4) BINARY.
000140   77  REM2        PIC S9(4) BINARY.
000150   77  REM3        PIC S9(4) BINARY.
000160   01  MMDD-TABLE.
000170      02  DAYS     PIC X(24)
000180                   VALUE  "312831303130313130313031".
000190      02  MMDD     REDEFINES DAYS
000200                   PIC 99 OCCURS 12 TIMES.
000210*
000220 LINKAGE SECTION.
000230   01  INPUT-DATE.
000240         03  YY    PIC 9999.
000250         03  MM    PIC 99.
000260         03  DD    PIC 99.
000270   01  OUTPUT-DAYS PIC S9(8)  BINARY.
000280*
000290 PROCEDURE DIVISION  USING INPUT-DATE OUTPUT-DAYS.
000300*
000310* Compute leap years, if any.
000320     COMPUTE LEAP-YEAR = (YY - 1900 - 1) / 4.
000330* Compute the total number of days from last year.
000340     COMPUTE TOTAL-DAYS = (YY - 1900) * 365 + LEAP-YEAR.
000350*
000360* Determine the number of days in February.
000370     DIVIDE YY BY 4   GIVING WORK-YEAR REMAINDER REM1.
000380     DIVIDE YY BY 100 GIVING WORK-YEAR REMAINDER REM2.
000390     DIVIDE YY BY 400 GIVING WORK-YEAR REMAINDER REM3.
000400*
000410* Leap year is a multiple of 4 of 400, not 100.
000420     IF REM1 = 0 THEN
000430       IF REM2 NOT = 0 OR
000440           REM3    = 0 THEN
000450         MOVE "29" TO MMDD(2)
000460       END-IF
000470     END-IF.
000480*
000490* Compute the number of days in the year.
000500     PERFORM  VARYING CTR FROM 1 BY 1 UNTIL CTR = MM
000510       COMPUTE TOTAL-DAYS = TOTAL-DAYS + MMDD(CTR)
000520     END-PERFORM.
000530*
000540* Compute OUTPUT-DAYS.
000550     COMPUTE OUTPUT-DAYS = TOTAL-DAYS + DD.
000560*
000570     EXIT PROGRAM.
000580 END PROGRAM  SUMCALC.
