000010 CLASS-ID. ABOUT INHERITS FORM.
000020 ENVIRONMENT DIVISION.
000030 CONFIGURATION SECTION.
000040 REPOSITORY.
000050     CLASS FORM AS "System.Windows.Forms.Form"
000051     CLASS APPLICATION AS "System.Windows.Forms.Application"
000052     CLASS SYS-ENVIRONMENT AS "System.Environment"
000060     CLASS BUTTON AS "System.Windows.Forms.Button"
000070     CLASS PICTUREBOX AS "System.Windows.Forms.PictureBox"
000080     CLASS TEXTBOX AS "System.Windows.Forms.TextBox"
000090     CLASS CONTAINER AS "System.ComponentModel.Container"
000091     ENUM SCROLLBARS AS "System.Windows.Forms.ScrollBars"
000092     ENUM HORIZONTAL-ALIGNMENT AS "System.Windows.Forms.HorizontalAlignment"
000100     DELEGATE EVENTHANDLER AS "System.EventHandler"
000110     CLASS EVENTARGS AS "System.EventArgs"
000120     CLASS POINT AS "System.Drawing.Point"
000130     CLASS DRAWING-SIZE AS "System.Drawing.Size"
000140     CLASS FONT AS "System.Drawing.Font"
000150     CLASS IMAGE AS "System.Drawing.Image"
000160     CLASS PATH AS "System.IO.Path"
000170     CLASS SYS-OBJECT AS "System.Object"
000180     CLASS SYS-STRING AS "System.String"
000181     CLASS STRING-BUILDER AS "System.Text.StringBuilder"
000190     CLASS SYS-BOOLEAN AS "System.Boolean"
000200     CLASS CONTROL-COLLECTION AS "System.Windows.Forms.Control+ControlCollection"
000210     PROPERTY PROP-LOCATION AS "Location"
000220     PROPERTY PROP-SIZE AS "Size"
000230     PROPERTY PROP-NEWLINE AS "NewLine"
000240     PROPERTY PROP-TABINDEX AS "TabIndex"
000250     PROPERTY PROP-TEXT AS "Text"
000260     PROPERTY PROP-TEXT-ALIGN AS "TextAlign"
000270     ENUM CONTENT-ALIGNMENT AS "System.Drawing.ContentAlignment"
000280     PROPERTY PROP-MIDDLE-CENTER AS "MiddleCenter"
000290     PROPERTY PROP-FONT AS "Font"
000300     ENUM FONT-STYLE AS "System.Drawing.FontStyle"
000310     PROPERTY PROP-BOLD AS "Bold"
000320     PROPERTY APP-CONTROLS AS "Controls"
000330     PROPERTY PROP-TABSTOP AS "TabStop"
000340     PROPERTY PROP-SELECTION-LENGTH AS "SelectionLength"
000350     PROPERTY PROP-AUTOSCALEBASESIZE AS "AutoScaleBaseSize"
000360     PROPERTY PROP-CLIENT-SIZE AS "ClientSize"
000370     PROPERTY PROP-EXECUTABLE-PATH AS "ExecutablePath"
000380     ENUM PICTUREBOX-SIZEMODE AS "System.Windows.Forms.PictureBoxSizeMode"
000381     PROPERTY PROP-SIZE-MODE AS "SizeMode"
000382     PROPERTY PROP-CENTER AS "Center"
000390     PROPERTY PROP-CENTER-IMAGE AS "CenterImage"
000400     PROPERTY PROP-IMAGE AS "Image"
000401     PROPERTY PROP-VERTICAL AS "Vertical"
000402     PROPERTY PROP-MULTI-LINE AS "Multiline"
000403     PROPERTY PROP-READ-ONLY AS "ReadOnly"
000410     PROPERTY PROP-FORM-BORDER-STYLE AS "FormBorderStyle"
000420     ENUM FORM-BORDER-STYLE AS "System.Windows.Forms.FormBorderStyle"
000421     PROPERTY PROP-CONTROL-BOX AS "ControlBox"
000422     PROPERTY PROP-SCROLLBARS AS "ScrollBars"
000430     PROPERTY PROP-FIXED-DIALOG AS "FixedDialog"
000440     PROPERTY PROP-MAXIMIZE-BOX AS "MaximizeBox"
000450     PROPERTY PROP-MINIMIZE-BOX AS "MinimizeBox".
000460 OBJECT.
000470 DATA DIVISION.
000480 WORKING-STORAGE SECTION.
000490 01 COMPONENTS OBJECT REFERENCE CONTAINER.
000500 01 OK-BUTTON OBJECT REFERENCE BUTTON.
000510 01 PICTUREBOX1 OBJECT REFERENCE PICTUREBOX.
000520 01 TEXTBOX1 OBJECT REFERENCE TEXTBOX.
000530 PROCEDURE DIVISION.
000540 METHOD-ID. NEW.
000550 DATA DIVISION.
000560 WORKING-STORAGE SECTION.
000570 01 APP-PATH OBJECT REFERENCE SYS-STRING.
000580 01 IMAGE-PATH OBJECT REFERENCE SYS-STRING.
000590 01 NEWLINE OBJECT REFERENCE SYS-STRING.
000600 01 ABOUT-TEXT OBJECT REFERENCE STRING-BUILDER.
000610 PROCEDURE DIVISION.
000620     INVOKE SELF "InitializeComponent".
000630     INVOKE STRING-BUILDER "NEW" USING BY VALUE "Version 2"
000640         RETURNING ABOUT-TEXT.
000650     SET NEWLINE TO PROP-NEWLINE OF SYS-ENVIRONMENT.
000660     INVOKE ABOUT-TEXT "Append" USING BY VALUE NEWLINE
000670         RETURNING ABOUT-TEXT.
000680     INVOKE ABOUT-TEXT "Append" USING BY VALUE
000690         "Cisco is half Border Collie and half Australian Cattle Dog.
000700-        " He is 5 years old and enjoys playing frisbee, "
000710         RETURNING ABOUT-TEXT.
000720     INVOKE ABOUT-TEXT "Append" USING BY VALUE
000730         "going for hikes, chasing condensation trails, and
000740-        " biting piano pedals among other things."
000750         RETURNING ABOUT-TEXT.
000760     SET PROP-TEXT OF TEXTBOX1 TO ABOUT-TEXT::"ToString"().
000770     MOVE 0 TO PROP-SELECTION-LENGTH OF TEXTBOX1.
000780     SET APP-PATH TO PROP-EXECUTABLE-PATH OF APPLICATION.
000790     INVOKE PATH "GetDirectoryName" USING BY VALUE APP-PATH
000800         RETURNING APP-PATH.
000810     SET IMAGE-PATH TO PATH::"Combine"(APP-PATH, "ABOUT.JPG").
000820     SET PROP-IMAGE OF PICTUREBOX1 TO IMAGE::"FromFile"(IMAGE-PATH).
000830 END METHOD NEW.
000840* 
000850 METHOD-ID. DISPOSE AS "Dispose" PROTECTED OVERRIDE.
000860 DATA DIVISION.
000870 WORKING-STORAGE SECTION.
000880 01 FLAG PIC 1 USAGE BIT.
000890 LINKAGE SECTION.
000900 01 DISPOSING OBJECT REFERENCE SYS-BOOLEAN.
000910 PROCEDURE DIVISION USING BY VALUE DISPOSING.
000920     SET FLAG TO DISPOSING.
000930     IF FLAG = B"1" AND COMPONENTS NOT = NULL THEN
000940         INVOKE COMPONENTS "Dispose"
000950     END-IF.
000960     INVOKE SUPER "Dispose" USING BY VALUE DISPOSING.
000970 END METHOD DISPOSE.
000980* 
000990 METHOD-ID. INITIALIZECOMPONENT AS "InitializeComponent".
001000 DATA DIVISION.
001010 WORKING-STORAGE SECTION.
001020 01 BOLD-FONT OBJECT REFERENCE FONT-STYLE.
001030 01 OK-EVENT OBJECT REFERENCE EVENTHANDLER.
001040 PROCEDURE DIVISION.
001050     INVOKE BUTTON "NEW" RETURNING OK-BUTTON.
001060     INVOKE PICTUREBOX "NEW" RETURNING PICTUREBOX1.
001070     INVOKE TEXTBOX "NEW" RETURNING TEXTBOX1.
001080     INVOKE SELF "SuspendLayout".
001090*
001100     SET PROP-LOCATION OF PICTUREBOX1 TO POINT::"NEW" (24, 8).
001110     SET PROP-SIZE OF PICTUREBOX1 TO DRAWING-SIZE::"NEW" (304, 216).
001120     SET PROP-SIZE-MODE OF PICTUREBOX1 TO PROP-CENTER-IMAGE OF PICTUREBOX-SIZEMODE.
001130     SET PROP-TABSTOP OF PICTUREBOX1 TO B"0".
001140     INVOKE APP-CONTROLS OF SELF "Add" USING BY VALUE PICTUREBOX1.
001150*
001160     SET BOLD-FONT TO PROP-BOLD OF FONT-STYLE.
001170* 
001180     SET PROP-FONT OF TEXTBOX1 TO
001190         FONT::"NEW" ("Microsoft Sans Serif", 10.0, BOLD-FONT).
001200     SET PROP-LOCATION OF TEXTBOX1 TO POINT::"NEW"(16, 240).
001210     SET PROP-MULTI-LINE OF TEXTBOX1 TO B"1".
001220     SET PROP-READ-ONLY OF TEXTBOX1 TO B"1".
001230     SET PROP-SCROLLBARS OF TEXTBOX1 TO PROP-VERTICAL OF SCROLLBARS.
001240     SET PROP-SIZE OF TEXTBOX1 TO DRAWING-SIZE::"NEW"(320, 72).
001250     SET PROP-TEXT-ALIGN OF TEXTBOX1 TO
001260         PROP-CENTER OF HORIZONTAL-ALIGNMENT.
001270     INVOKE APP-CONTROLS OF SELF "Add" USING BY VALUE TEXTBOX1.
001280*
001290     SET PROP-FONT OF OK-BUTTON TO
001300         FONT::"NEW" ("Microsoft Sans Serif", 12.0, BOLD-FONT).
001310     SET PROP-LOCATION OF OK-BUTTON TO POINT::"NEW" (144, 328).
001320     SET PROP-SIZE OF OK-BUTTON TO DRAWING-SIZE::"NEW" (75, 32).
001330     SET PROP-TEXT OF OK-BUTTON TO "&OK".
001340     INVOKE EVENTHANDLER "NEW" USING BY VALUE SELF "OK_Click"
001350         RETURNING OK-EVENT.
001360     INVOKE OK-BUTTON "add_Click" USING BY VALUE OK-EVENT.
001370     INVOKE APP-CONTROLS OF SELF "Add" USING BY VALUE OK-BUTTON.
001380* 
001390     SET PROP-TEXT OF SELF TO "About My Dog".
001400     SET PROP-AUTOSCALEBASESIZE OF SELF TO DRAWING-SIZE::"NEW" (5, 13).
001410     SET PROP-CLIENT-SIZE OF SELF TO DRAWING-SIZE::"NEW" (360, 375).
001420     SET PROP-CONTROL-BOX OF SELF TO B"0".
001430     SET PROP-FORM-BORDER-STYLE OF SELF TO PROP-FIXED-DIALOG OF FORM-BORDER-STYLE.
001440     SET PROP-MAXIMIZE-BOX OF SELF TO B"0".
001450     SET PROP-MINIMIZE-BOX OF SELF TO B"0".
001460     INVOKE SELF "ResumeLayout" USING BY VALUE B'0'.
001470 END METHOD INITIALIZECOMPONENT.
001480* 
001490 METHOD-ID. OK_CLICK AS "OK_Click".
001500 DATA DIVISION.
001510 WORKING-STORAGE SECTION.
001520 01 DISPOSING OBJECT REFERENCE SYS-BOOLEAN.
001530 LINKAGE SECTION.
001540 01 SENDER OBJECT REFERENCE SYS-OBJECT.
001550 01 E OBJECT REFERENCE EVENTARGS.
001560 PROCEDURE DIVISION USING BY VALUE SENDER E.
001570     SET DISPOSING TO B"1".
001580     INVOKE SELF "Dispose" USING BY VALUE DISPOSING.
001590 END METHOD OK_CLICK.
001600* 
001610 END OBJECT.
001620 END CLASS ABOUT.
001630
001640