000010 CLASS-ID. WALK INHERITS FORM.
000020 ENVIRONMENT DIVISION.
000030 CONFIGURATION SECTION.
000040 REPOSITORY.
000050     CLASS FORM AS "System.Windows.Forms.Form"
000060     CLASS REMINDER
000061     CLASS ABOUT
000070     CLASS RESOURCEMANAGER AS "System.Resources.ResourceManager"
000080     CLASS APPLICATION AS "System.Windows.Forms.Application"
000090     CLASS CONTAINER AS "System.ComponentModel.Container"
000100     CLASS BUTTON AS "System.Windows.Forms.Button"
000110     CLASS TIMER AS "System.Windows.Forms.Timer"
000120     CLASS PICTUREBOX AS "System.Windows.Forms.PictureBox"
000130     CLASS BITMAP AS "System.Drawing.Bitmap"
000140     CLASS IMAGE AS "System.Drawing.Image"
000150     DELEGATE EVENTHANDLER AS "System.EventHandler"
000160     CLASS EVENTARGS AS "System.EventArgs"
000170     CLASS POINT AS "System.Drawing.Point"
000180     CLASS DRAWING-SIZE AS "System.Drawing.Size"
000190     CLASS FONT AS "System.Drawing.Font"
000200     CLASS SYS-OBJECT AS "System.Object"
000210     CLASS SYS-STRING AS "System.String"
000220     CLASS SYS-BOOLEAN AS "System.Boolean"
000230     CLASS CONTROL-COLLECTION AS "System.Windows.Forms.Control+ControlCollection"
000240     CLASS MAIN-MENU AS "System.Windows.Forms.MainMenu"
000250     CLASS MENU-ITEM AS "System.Windows.Forms.MenuItem"
000260     CLASS PATH AS "System.IO.Path"
000261     INTERFACE ICOMPONENT AS "System.ComponentModel.IComponent"
000262     INTERFACE IWIN32-WINDOW AS "System.Windows.Forms.IWin32Window"
000270     PROPERTY PROP-INTERVAL AS "Interval"
000280     PROPERTY PROP-ENABLED AS "Enabled"
000290     PROPERTY PROP-LOCATION AS "Location"
000300     PROPERTY PROP-SIZE AS "Size"
000310     PROPERTY PROP-TABINDEX AS "TabIndex"
000320     PROPERTY PROP-FONT AS "Font"
000330     ENUM FONT-STYLE AS "System.Drawing.FontStyle"
000340     PROPERTY PROP-BOLD AS "Bold"
000350     PROPERTY PROP-TEXT AS "Text"
000360     PROPERTY PROP-INDEX AS "Index"
000380     PROPERTY APP-CONTROLS AS "Controls"
000390     PROPERTY PROP-TABSTOP AS "TabStop"
000400     PROPERTY PROP-AUTOSCALEBASESIZE AS "AutoScaleBaseSize"
000410     PROPERTY PROP-CLIENTSIZE AS "ClientSize"
000420     PROPERTY PROP-IMAGE AS "Image"
000430     ENUM PICTUREBOX-SIZEMODE AS "System.Windows.Forms.PictureBoxSizeMode"
000440     PROPERTY PROP-SIZE-MODE AS "SizeMode"
000450     PROPERTY PROP-CENTER-IMAGE AS "CenterImage"
000460     PROPERTY PROP-EXECUTABLE-PATH AS "ExecutablePath"
000461     PROPERTY PROP-MENU AS "Menu"
000470     PROPERTY PROP-MENU-ITEMS AS "MenuItems"
000480     .
000490 STATIC.
000500 PROCEDURE DIVISION.
000510 METHOD-ID. MAIN.
000520 DATA DIVISION.
000530 WORKING-STORAGE SECTION.
000540 01 OBJ OBJECT REFERENCE WALK.
000550 PROCEDURE DIVISION.
000560     INVOKE WALK "NEW" RETURNING OBJ.
000570     INVOKE APPLICATION "Run" USING BY VALUE OBJ.
000580 END METHOD MAIN.
000590 END STATIC.
000600 OBJECT.
000610 DATA DIVISION.
000620 WORKING-STORAGE SECTION.
000630 01 COMPONENTS OBJECT REFERENCE CONTAINER.
000640 01 BUTTON1 OBJECT REFERENCE BUTTON.
000650 01 TIMER1 OBJECT REFERENCE TIMER.
000660 01 PICTUREBOX1 OBJECT REFERENCE PICTUREBOX.
000670 01 MAINMENU1 OBJECT REFERENCE MAIN-MENU.
000680 01 FILE-MENU OBJECT REFERENCE MENU-ITEM.
000690 01 EXIT-MENU OBJECT REFERENCE MENU-ITEM.
000700 01 HELP-MENU OBJECT REFERENCE MENU-ITEM.
000710 01 ABOUT-MENU OBJECT REFERENCE MENU-ITEM.
000720 PROCEDURE DIVISION.
000730*
000740 METHOD-ID. NEW.
000750 DATA DIVISION.
000760 WORKING-STORAGE SECTION.
000770 01 APP-PATH OBJECT REFERENCE SYS-STRING.
000780 01 IMAGE-PATH OBJECT REFERENCE SYS-STRING.
000790 PROCEDURE DIVISION.
000800     INVOKE CONTAINER "NEW" RETURNING COMPONENTS.
000810     INVOKE SELF "InitializeComponent".
000820     SET APP-PATH TO PROP-EXECUTABLE-PATH OF APPLICATION.
000830     INVOKE PATH "GetDirectoryName" USING BY VALUE APP-PATH RETURNING APP-PATH.
000840     INVOKE PATH "Combine" USING BY VALUE APP-PATH "MAIN.JPG" RETURNING IMAGE-PATH.
000850     SET PROP-IMAGE OF PICTUREBOX1 TO IMAGE::"FromFile" (IMAGE-PATH).
000860 END METHOD NEW.
000870*
000880 METHOD-ID. DISPOSE AS "Dispose" PROTECTED OVERRIDE.
000890 DATA DIVISION.
000900 WORKING-STORAGE SECTION.
000910 01 FLAG PIC 1 USAGE BIT.
000920 LINKAGE SECTION.
000930 01 DISPOSING OBJECT REFERENCE SYS-BOOLEAN.
000940 PROCEDURE DIVISION USING BY VALUE DISPOSING.
000950     SET FLAG TO DISPOSING.
000960     IF FLAG = B"1" AND COMPONENTS NOT = NULL THEN
000970         INVOKE COMPONENTS "Dispose"
000980     END-IF.
000990     INVOKE SUPER "Dispose" USING BY VALUE DISPOSING.
001000 END METHOD DISPOSE.
001010*
001020 METHOD-ID. INITIALIZECOMPONENT AS "InitializeComponent".
001030 DATA DIVISION.
001040 WORKING-STORAGE SECTION.
001050 01 TICK-EVENT OBJECT REFERENCE EVENTHANDLER.
001060 01 CLICK-EVENT OBJECT REFERENCE EVENTHANDLER.
001070 01 EXIT-EVENT OBJECT REFERENCE EVENTHANDLER.
001080 01 ABOUT-EVENT OBJECT REFERENCE EVENTHANDLER.
001090 01 BOLD-FONT OBJECT REFERENCE FONT-STYLE.
001100 PROCEDURE DIVISION.
001110     INVOKE PICTUREBOX "NEW" RETURNING PICTUREBOX1.
001120     INVOKE BUTTON "NEW" RETURNING BUTTON1.
001130     INVOKE TIMER "NEW" USING BY VALUE COMPONENTS RETURNING TIMER1.
001140     INVOKE MAIN-MENU "NEW" RETURNING MAINMENU1.
001150     INVOKE MENU-ITEM "NEW" RETURNING FILE-MENU.
001160     INVOKE MENU-ITEM "NEW" RETURNING EXIT-MENU.
001170     INVOKE MENU-ITEM "NEW" RETURNING HELP-MENU.
001180     INVOKE MENU-ITEM "NEW" RETURNING ABOUT-MENU.
001190     INVOKE SELF "SuspendLayout".
001200*
001210     SET PROP-LOCATION OF PICTUREBOX1 TO POINT::"NEW" (24, 24).
001220     SET PROP-SIZE OF PICTUREBOX1 TO DRAWING-SIZE::"NEW" (240, 128).
001230     SET PROP-TABSTOP OF PICTUREBOX1 TO B'0'.
001240     SET PROP-SIZE-MODE OF PICTUREBOX1 TO PROP-CENTER-IMAGE OF PICTUREBOX-SIZEMODE.
001250     INVOKE APP-CONTROLS OF SELF "Add" USING BY VALUE PICTUREBOX1.
001260* 
001270     SET PROP-LOCATION OF BUTTON1 TO POINT::"NEW" (40, 184).
001280     SET PROP-SIZE OF BUTTON1 TO DRAWING-SIZE::"NEW" (208, 48).
001290     MOVE 0 TO PROP-TABINDEX OF BUTTON1.
001300     SET PROP-TEXT OF BUTTON1 TO "&Stop It!".
001310     SET BOLD-FONT TO PROP-BOLD OF FONT-STYLE.
001320     SET PROP-FONT OF BUTTON1 TO
001330         FONT::"NEW" ("Microsoft Sans Serif", 12.0, BOLD-FONT).
001340     INVOKE EVENTHANDLER "NEW" USING BY VALUE SELF "Button1_Click"
001350         RETURNING CLICK-EVENT.
001360     INVOKE BUTTON1 "add_Click" USING BY VALUE CLICK-EVENT.
001370     INVOKE APP-CONTROLS OF SELF "Add" USING BY VALUE BUTTON1.
001380*
001390     MOVE 7000 TO PROP-INTERVAL OF TIMER1.
001400     SET PROP-ENABLED OF TIMER1 TO B'1'.
001410     INVOKE EVENTHANDLER "NEW" USING BY VALUE SELF "Timer1_Tick"
001420         RETURNING TICK-EVENT.
001430     INVOKE TIMER1 "add_Tick" USING BY VALUE TICK-EVENT.
001440*
001450     INVOKE PROP-MENU-ITEMS OF MAINMENU1 "Add" USING BY VALUE FILE-MENU.
001460     INVOKE PROP-MENU-ITEMS OF MAINMENU1 "Add" USING BY VALUE HELP-MENU.
001470*
001480     MOVE 0 TO PROP-INDEX OF FILE-MENU.
001490     INVOKE PROP-MENU-ITEMS OF FILE-MENU "Add" USING BY VALUE EXIT-MENU.
001500     SET PROP-TEXT OF FILE-MENU TO "&File".
001510*
001520     MOVE 0 TO PROP-INDEX OF EXIT-MENU.
001530     SET PROP-TEXT OF EXIT-MENU TO "E&xit".
001540     INVOKE EVENTHANDLER "NEW" USING BY VALUE SELF "Exit_Click"
001550         RETURNING EXIT-EVENT.
001560     INVOKE EXIT-MENU "add_Click" USING BY VALUE EXIT-EVENT.
001570*
001580     MOVE 1 TO PROP-INDEX OF HELP-MENU.
001590     INVOKE PROP-MENU-ITEMS OF HELP-MENU "Add" USING BY VALUE ABOUT-MENU.
001600     SET PROP-TEXT OF HELP-MENU TO "&Help".
001610*
001620     MOVE 0 TO PROP-INDEX OF ABOUT-MENU.
001630     SET PROP-TEXT OF ABOUT-MENU TO "&About".
001640     INVOKE EVENTHANDLER "NEW" USING BY VALUE SELF "About_Click"
001650         RETURNING ABOUT-EVENT.
001660     INVOKE ABOUT-MENU "add_Click" USING BY VALUE ABOUT-EVENT.
001670*
001671     SET PROP-MENU OF SELF TO MAINMENU1.
001680     SET PROP-TEXT OF SELF TO "My Dog".
001690     SET PROP-AUTOSCALEBASESIZE OF SELF TO DRAWING-SIZE::"NEW" (5, 13).
001700     SET PROP-CLIENTSIZE OF SELF TO DRAWING-SIZE::"NEW" (292, 274).
001710     INVOKE SELF "ResumeLayout" USING BY VALUE B'0'.
001720 END METHOD INITIALIZECOMPONENT.
001730*
001740 METHOD-ID. BUTTON1_CLICK AS "Button1_Click".
001750 DATA DIVISION.
001760 WORKING-STORAGE SECTION.
001770 01 ENABLED PIC 1 USAGE BIT.
001780 LINKAGE SECTION.
001790 01 SENDER OBJECT REFERENCE SYS-OBJECT.
001800 01 E OBJECT REFERENCE EVENTARGS.
001810 PROCEDURE DIVISION USING BY VALUE SENDER E.
001820     SET ENABLED TO PROP-ENABLED OF TIMER1.
001830     IF ENABLED = B'1' THEN
001840         SET PROP-ENABLED OF TIMER1 TO B'0'
001850         SET PROP-TEXT OF BUTTON1 TO "&Remind me"
001860     ELSE
001870         SET PROP-ENABLED OF TIMER1 TO B'1'
001880         SET PROP-TEXT OF BUTTON1 TO "&Stop it!"
001890     END-IF.
001900 END METHOD BUTTON1_CLICK.
001910*
001920 METHOD-ID. TIMER1_TICK AS "Timer1_Tick".
001930 DATA DIVISION.
001940 WORKING-STORAGE SECTION.
001950 01 REMINDER-OBJ OBJECT REFERENCE REMINDER.
001951 01 COMPONENT-OBJ OBJECT REFERENCE ICOMPONENT.
001960 LINKAGE SECTION.
001970 01 SENDER OBJECT REFERENCE SYS-OBJECT.
001980 01 E OBJECT REFERENCE EVENTARGS.
001990 PROCEDURE DIVISION USING BY VALUE SENDER E.
002000     INVOKE REMINDER "NEW" USING BY VALUE SELF RETURNING REMINDER-OBJ.
002010     INVOKE REMINDER-OBJ "Show".
002011     SET COMPONENT-OBJ TO REMINDER-OBJ AS ICOMPONENT.
002020     INVOKE COMPONENTS "Add" USING BY VALUE COMPONENT-OBJ.
002030 END METHOD TIMER1_TICK.
002040*
002050 METHOD-ID. EXIT_CLICK AS "Exit_Click".
002060 DATA DIVISION.
002070 LINKAGE SECTION.
002080 01 SENDER OBJECT REFERENCE SYS-OBJECT.
002090 01 E OBJECT REFERENCE EVENTARGS.
002100 PROCEDURE DIVISION USING BY VALUE SENDER E.
002110     INVOKE APPLICATION "Exit".
002120 END METHOD EXIT_CLICK.
002121*
002122 METHOD-ID. ABOUT_CLICK AS "About_Click".
002123 DATA DIVISION.
002124 WORKING-STORAGE SECTION.
002125 01 ABOUT-FORM OBJECT REFERENCE ABOUT.
002126 01 WIN32-WINDOW OBJECT REFERENCE IWIN32-WINDOW.
002127 LINKAGE SECTION.
002128 01 SENDER OBJECT REFERENCE SYS-OBJECT.
002129 01 E OBJECT REFERENCE EVENTARGS.
002130 PROCEDURE DIVISION USING BY VALUE SENDER E.
002131     INVOKE ABOUT "NEW" RETURNING ABOUT-FORM.
002132     SET WIN32-WINDOW TO SELF AS IWIN32-WINDOW.
002133     INVOKE ABOUT-FORM "ShowDialog" USING BY VALUE WIN32-WINDOW.
002134 END METHOD ABOUT_CLICK.
002141*
002142 METHOD-ID. DECREMENT-TIMER.
002143 DATA DIVISION.
002144 WORKING-STORAGE SECTION.
002145 01 INTERVAL COMP-2.
002146 PROCEDURE DIVISION.
002147     MOVE PROP-INTERVAL OF TIMER1 TO INTERVAL.
002148     IF INTERVAL > 1000 THEN
002149         SUBTRACT 1000 FROM INTERVAL
002150         MOVE INTERVAL TO PROP-INTERVAL OF TIMER1
002151     END-IF.
002152 END METHOD DECREMENT-TIMER.
002153*
002154 METHOD-ID. RESET-TIMER.
002155 PROCEDURE DIVISION.
002156     MOVE 7000 TO PROP-INTERVAL OF TIMER1.
002157 END METHOD RESET-TIMER.
002158*
002159 END OBJECT.
002160*
002161 END CLASS WALK.
002162
002170