       PROGRAM-ID. CHANGE.
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES.
           ARGUMENT-VALUE IS ARGVAL.
       REPOSITORY. 
           CLASS STREAMREADER AS "System.IO.StreamReader"
           CLASS REGEX AS "System.Text.RegularExpressions.Regex"
           CLASS SYSENVIRONMENT AS "System.Environment"
           CLASS STRINGBUILDER AS "System.Text.StringBuilder"
           CLASS SYSSTRING AS "System.String"
           PROPERTY CURRENTDIRECTORY AS "CurrentDirectory".
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01 READER OBJECT REFERENCE STREAMREADER.
       01 SOURCE-LINE OBJECT REFERENCE SYSSTRING.
       01 SEARCH-EXPR OBJECT REFERENCE SYSSTRING.
       01 REPLACE-BUILDER OBJECT REFERENCE STRINGBUILDER.
       01 REPLACE-EXPR OBJECT REFERENCE SYSSTRING.
       01 CURDIR OBJECT REFERENCE SYSSTRING.
       01 FILE-NAME OBJECT REFERENCE SYSSTRING.
       01 ISMATCH PIC 1.
       01 SRCLINE PIC X(128).
       01 FNAME PIC X(256) VALUE "AreaCode.chg".
       PROCEDURE DIVISION.
           INVOKE STREAMREADER "NEW"
               USING BY VALUE FNAME
               RETURNING READER.
           SET SEARCH-EXPR TO "(?<x>areacode.ixd)".
           SET CURDIR TO CURRENTDIRECTORY OF SYSENVIRONMENT.
           INVOKE STRINGBUILDER "NEW"
               USING BY VALUE CURDIR
               RETURNING REPLACE-BUILDER.
           INVOKE REPLACE-BUILDER "Append"
               USING BY VALUE "\${x}"
               RETURNING REPLACE-BUILDER.
           INVOKE REPLACE-BUILDER "ToString" RETURNING REPLACE-EXPR.
           SET SOURCE-LINE TO READER::"ReadLine" ()
           MOVE B'0' TO ISMATCH
           PERFORM UNTIL SOURCE-LINE = NULL
               SET ISMATCH TO REGEX::"IsMatch" (SOURCE-LINE, SEARCH-EXPR)
               IF ISMATCH = B'1' THEN
                   SET SOURCE-LINE TO
                     REGEX::"Replace" (SOURCE-LINE, SEARCH-EXPR, REPLACE-EXPR)
               END-IF
               SET SRCLINE TO SOURCE-LINE
               DISPLAY SRCLINE
               SET SOURCE-LINE TO READER::"ReadLine" ()
               MOVE B'0' TO ISMATCH
           END-PERFORM
       END PROGRAM CHANGE.
