<%@ Page Language="COBOL" aspcompat=true %>
<html>
<title> ASP.NET Code Generation Sample </title>
<body>

<h2>ASP.NET Code Generation Sample</h2>

This page tests all the different types of code generation required by ASP.NET.

<script runat=server>
ENVIRONMENT DIVISION.
CONFIGURATION SECTION.
REPOSITORY.
    PROPERTY P-lblOutput AS "lblOutput"
    PROPERTY P-Text AS "Text"
    PROPERTY P-Columns AS "Columns"
    PROPERTY P-Rows AS "Rows"
    PROPERTY DataSource
    PROPERTY P-repeater1 AS "repeater1"
    PROPERTY Response
    CLASS DataBinder AS "System.Web.UI.DataBinder"
    CLASS Sys-Object AS "System.Object"
    CLASS Sys-String AS "System.String"
    CLASS Sys-EventArgs AS "System.EventArgs"
    CLASS JapaneseCalendar AS "System.Globalization.JapaneseCalendar"
    INTERFACE ICollection AS "System.Collections.ICollection"
    CLASS StringBuilder AS "System.Text.StringBuilder"
    CLASS DataTable AS "System.Data.DataTable"
    CLASS DataRow AS "System.Data.DataRow"
    CLASS DataColumn AS "System.Data.DataColumn"
    CLASS DataView AS "System.Data.DataView"
    CLASS Sys-Type AS "System.Type".
OBJECT.
DATA DIVISION.
WORKING-STORAGE SECTION.
01 ctr PIC S9(9) COMP-5.
PROCEDURE DIVISION.
METHOD-ID. OnLoad OVERRIDE PROTECTED.
DATA DIVISION.
WORKING-STORAGE SECTION.
01 cal OBJECT REFERENCE JapaneseCalendar.
01 flag PIC 1 USAGE BIT.
01 dataSource OBJECT REFERENCE ICollection.
01 wk OBJECT REFERENCE Sys-Object.
LINKAGE SECTION.
01 args OBJECT REFERENCE Sys-EventArgs.
PROCEDURE DIVISION USING BY VALUE args.
    INVOKE SUPER "OnLoad" USING BY VALUE args.
    SET P-Text OF lblOutput TO "OnLoad called.".
*>
*> Do databind
*>
    SET flag TO IsPostBack OF SELF.
    IF flag = B"0" THEN
        INVOKE SELF "CreateDataSource" RETURNING dataSource
        SET wk TO dataSource AS Sys-Object
        SET DataSource OF repeater1 TO wk
        INVOKE repeater1 "DataBind"
    END-IF
END METHOD OnLoad.
*>
*> This is an autohookup method
*>
METHOD-ID. Page_PreRender.
DATA DIVISION.
WORKING-STORAGE SECTION.
01 str OBJECT REFERENCE StringBuilder.
01 txt OBJECT REFERENCE Sys-String.
PROCEDURE DIVISION.
    SET txt TO P-Text OF lblOutput
    INVOKE StringBuilder "NEW" USING BY VALUE txt
        RETURNING str.
    INVOKE str "Append" USING BY VALUE "<br>PreRender called"
        RETURNING str.
    SET P-Text OF lblOutput TO str::"ToString"().
END METHOD Page_PreRender.
*>
METHOD-ID. CreateDataSource.
DATA DIVISION.
WORKING-STORAGE SECTION.
01 dt OBJECT REFERENCE DataTable.
01 dr OBJECT REFERENCE DataRow.
01 dc OBJECT REFERENCE DataColumn.
01 t OBJECT REFERENCE Sys-Type.
01 str OBJECT REFERENCE StringBuilder.
01 dv OBJECT REFERENCE DataView.
01 txt OBJECT REFERENCE Sys-String.
01 i PIC S9(9) COMP-5.
LINKAGE SECTION.
01 collection OBJECT REFERENCE ICollection.
PROCEDURE DIVISION RETURNING collection.
    INVOKE DataTable "NEW" RETURNING dt.
*>
    INVOKE Sys-Type "GetType" USING BY VALUE "System.Int32" RETURNING t.
    INVOKE DataColumn "NEW" USING BY VALUE "DataColumn1" t RETURNING dc.
    INVOKE P-Columns OF dt "Add" USING BY VALUE dc.
*>
    INVOKE Sys-Type "GetType" USING BY VALUE "System.String" RETURNING t.
    INVOKE DataColumn "NEW" USING BY VALUE "DataColumn2" t RETURNING dc.
    INVOKE P-Columns OF dt "Add" USING BY VALUE dc.
*>
    PERFORM VARYING i FROM 1 BY 1 UNTIL i >= 6
        INVOKE dt "NewRow" RETURNING dr
*>
        INVOKE dr "set_Item" USING BY VALUE 0 i
*>
        INVOKE StringBuilder "NEW" USING BY VALUE "Item " RETURNING str
        INVOKE str "Append" USING BY VALUE i RETURNING str
        SET txt TO str::"ToString"()
        INVOKE dr "set_Item" USING BY VALUE 1 txt
*>
        INVOKE P-Rows OF dt "Add" USING BY VALUE dr
    END-PERFORM
*>
    INVOKE DataView "NEW" USING BY VALUE dt RETURNING dv.
*>
    SET collection TO dv AS ICollection.
END METHOD CreateDataSource.
*>
METHOD-ID. SelectedDateChanged.
DATA DIVISION.
LINKAGE SECTION.
01 src OBJECT REFERENCE Sys-Object.
01 args OBJECT REFERENCE Sys-EventArgs.
PROCEDURE DIVISION USING BY VALUE src args.
    INVOKE Response OF SELF "Write" USING BY VALUE "Selection Changed".
END METHOD SelectedDateChanged.
*>
END OBJECT.
</script>

<form runat="server">
    <hr>
    Control changed in server script block: <br>
    <asp:Label runat=server id=lblOutput />

    <hr>
    Control with properties and sub-properties: <br>
    <asp:Calendar id=cal runat=server SelectionMode=DayWeekMonth OnSelectionChanged=SelectedDateChanged>
      <DayStyle ForeColor=Green BackColor="#E8E8E8" />
      
    </asp:Calendar>

    <hr>
    The following loop uses &lt;% %&gt and &lt;%= %&gt blocks: <br>
    <% PERFORM VARYING ctr FROM 1 BY 1 UNTIL ctr >= 5 %>
        Writing Number: <%= ctr %> <br>
    <% END-PERFORM %>
    <hr>

    This is a data bound templated control: <br>
    <asp:Repeater id="repeater1" runat="server">
      <HeaderTemplate>
        <table cellspacing=0 cellpadding=1 style="font-family:verdana;font-size:8pt;border-collapse:collapse">
      </HeaderTemplate>
      <ItemTemplate>
        <tr>
          <td>
            <asp:Label runat="server" id="label1" text='<%# DataBinder::"Eval"(Container, "DataItem.DataColumn1", "{0}")%>'></asp:Label>
            :&nbsp;
            <asp:TextBox runat="server" id="textBox1" text='<%# DataBinder::"Eval"(Container, "DataItem.DataColumn2") %>'></asp:TextBox>
          </td>
        </tr>
      </ItemTemplate>
      <FooterTemplate>
        </table>
      </FooterTemplate>
    </asp:Repeater>

</form>
</body>
</html>
