<%@ Page Debug="true" %>
<%@ Assembly Name="Driver" %>

<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html> <head>
<title>Fibonacci Sample</title>
</head>

<script language="C#" runat="server">
string[] langs;

void SubmitClick(object o, EventArgs e)
  {
  string all = "";
  ArrayList alist = new ArrayList();
  for (int i = 0; i < langs.Length; i++)
    {
    Control c = FindControl("lang"+i);
    if (c != null && ((HtmlInputCheckBox) c).Checked)
      {
      all += langs[i] + "\n";
      alist.Add(i);
      }
    }

  int[] calls = new int[alist.Count];
  for (int i = 0; i < alist.Count; i++)
    calls[i] = (int) alist[i];

  string results = Fib.Driver.CallFuncs(10, 2, calls);

  resultText.InnerText = results;
  resultDiv.Visible = true;
  }

/*
 * fill table will fill the language checkbox table
 * it will try to fill an X by 3 table 
 */
void fillTable()
  {
//  langs = Fib.Driver.GetLangs(Request.PhysicalPath);
  langs = Fib.Driver.GetLangs(Request.PhysicalApplicationPath+"bin");
  int row_per_col = (langs.Length / 3) + langs.Length%3;

  HtmlTableRowCollection rc = langTable.Rows; // get row collection
  rc.Clear();			// clear the existing set

  HtmlTableCell[] cell = new HtmlTableCell[langs.Length];
  for (int i = 0; i < langs.Length; i++)
    {
    cell[i] = new HtmlTableCell();
    HtmlInputCheckBox box = new HtmlInputCheckBox();
    box.ID = "lang" + i;
    HtmlGenericControl g = new HtmlGenericControl();
    g.InnerText = langs[i];
    cell[i].Controls.Add(box);
    cell[i].Controls.Add(g);
    }

  for (int i = 0,
	 col2 = row_per_col,
	 col3 = row_per_col*2;
       i < row_per_col;
       i++, col2++, col3++)
    {
    HtmlTableRow r = new HtmlTableRow();
    HtmlTableCellCollection cc = r.Cells;
    cc.Add(cell[i]);
    if (col2 < langs.Length)
      {
      cc.Add(cell[col2]);
      if (col3 < langs.Length)
	cc.Add(cell[col3]);
      }
    rc.Add(r);
    }
  }

void Page_Load()
  {
  fillTable();
  }

</script>

<body>
<h1>Fibonacci Sample</h1>

<table width="60%" border="1" cellpadding="5" cellspacing="0" bordercolorlight="#000000" bordercolordark="#FFFFFF" style="font-size: x-small;">
  <tr><td>
Select the language components that you would like to have run in this segment.
<p>
<form runat=server>
<table id=langTable style="font-size: x-small;" cellpadding="0" runat=server>
  <tr><td></td></tr>
</table>
<br>
<center>
<input
   type=submit
   runat="server"
   value="Submit"
   id="submit"
   OnServerClick="SubmitClick"
   >
</center>
</form>
</table>

<div id=resultDiv Visible=false runat=server>
<b>Results:</b>
<center>
<textarea id=resultText cols=40 rows=16 runat=server></textarea>
</center>
</div>

<hr>
<address>
<a href="http://project7/bmerrill">Brad Merrill</a>
<a href="mailto:bmerrill@microsoft.com">&lt;bmerrill@microsoft.com&gt;</a>
</address>
<!-- hhmts start --> Last modified: Fri Jun 15 12:26:25 Pacific Daylight Time 2001 <!-- hhmts end -->
</body> </html>
